use ::libc;
extern "C" {
    #[no_mangle]
    fn sprintf(_: *mut libc::c_char, _: *const libc::c_char, _: ...)
     -> libc::c_int;
    #[no_mangle]
    fn malloc(_: libc::c_ulong) -> *mut libc::c_void;
    #[no_mangle]
    fn free(__ptr: *mut libc::c_void);
    #[no_mangle]
    fn exit(_: libc::c_int) -> !;
    #[no_mangle]
    fn memset(_: *mut libc::c_void, _: libc::c_int, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn strcat(_: *mut libc::c_char, _: *const libc::c_char)
     -> *mut libc::c_char;
    #[no_mangle]
    fn pthread_mutex_lock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_unlock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn logtime() -> *const libc::c_char;
    #[no_mangle]
    fn logprint(fmt: *const libc::c_char, _: ...);
    #[no_mangle]
    fn gettime_ms() -> u32_t;
    #[no_mangle]
    fn touch_memory(buf_0: *mut u8_t, size: size_t);
    #[no_mangle]
    fn _buf_used(buf_0: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_cont_read(buf_0: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_inc_readp(buf_0: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn buf_flush(buf_0: *mut buffer);
    #[no_mangle]
    fn _buf_resize(buf_0: *mut buffer, size: size_t);
    #[no_mangle]
    fn buf_init(buf_0: *mut buffer, size: size_t);
    #[no_mangle]
    fn buf_destroy(buf_0: *mut buffer);
    #[no_mangle]
    fn wake_controller();
    #[no_mangle]
    fn test_open(device: *const libc::c_char, rates: *mut libc::c_uint,
                 userdef_rates: bool) -> bool;
    #[no_mangle]
    fn gain(gain_0: s32_t, sample: s32_t) -> s32_t;
    #[no_mangle]
    fn to_gain(f: libc::c_float) -> s32_t;
}
pub type size_t = libc::c_ulong;
pub type __uint8_t = libc::c_uchar;
pub type __int32_t = libc::c_int;
pub type __uint32_t = libc::c_uint;
pub type int32_t = __int32_t;
pub type u_int8_t = __uint8_t;
pub type u_int32_t = __uint32_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_internal_list {
    pub __prev: *mut __pthread_internal_list,
    pub __next: *mut __pthread_internal_list,
}
pub type __pthread_list_t = __pthread_internal_list;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_mutex_s {
    pub __lock: libc::c_int,
    pub __count: libc::c_uint,
    pub __owner: libc::c_int,
    pub __nusers: libc::c_uint,
    pub __kind: libc::c_int,
    pub __spins: libc::c_short,
    pub __elision: libc::c_short,
    pub __list: __pthread_list_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_mutex_t {
    pub __data: __pthread_mutex_s,
    pub __size: [libc::c_char; 40],
    pub __align: libc::c_long,
}
pub type u8_t = u_int8_t;
pub type u32_t = u_int32_t;
pub type s32_t = int32_t;
pub type frames_t = u32_t;
pub type log_level = libc::c_uint;
pub const lSDEBUG: log_level = 4;
pub const lDEBUG: log_level = 3;
pub const lINFO: log_level = 2;
pub const lWARN: log_level = 1;
pub const lERROR: log_level = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct buffer {
    pub buf: *mut u8_t,
    pub readp: *mut u8_t,
    pub writep: *mut u8_t,
    pub wrap: *mut u8_t,
    pub size: size_t,
    pub base_size: size_t,
    pub mutex: pthread_mutex_t,
}
pub type output_state = libc::c_int;
pub const OUTPUT_START_AT: output_state = 5;
pub const OUTPUT_SKIP_FRAMES: output_state = 4;
pub const OUTPUT_PAUSE_FRAMES: output_state = 3;
pub const OUTPUT_RUNNING: output_state = 2;
pub const OUTPUT_BUFFER: output_state = 1;
pub const OUTPUT_STOPPED: output_state = 0;
pub const OUTPUT_OFF: output_state = -1;
pub type output_format = libc::c_uint;
pub const S16_LE: output_format = 3;
pub const S24_3LE: output_format = 2;
pub const S24_LE: output_format = 1;
pub const S32_LE: output_format = 0;
pub type fade_state = libc::c_uint;
pub const FADE_ACTIVE: fade_state = 2;
pub const FADE_DUE: fade_state = 1;
pub const FADE_INACTIVE: fade_state = 0;
pub type fade_dir = libc::c_uint;
pub const FADE_CROSS: fade_dir = 3;
pub const FADE_DOWN: fade_dir = 2;
pub const FADE_UP: fade_dir = 1;
pub type fade_mode = libc::c_uint;
pub const FADE_INOUT: fade_mode = 4;
pub const FADE_OUT: fade_mode = 3;
pub const FADE_IN: fade_mode = 2;
pub const FADE_CROSSFADE: fade_mode = 1;
pub const FADE_NONE: fade_mode = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct outputstate {
    pub state: output_state,
    pub format: output_format,
    pub device: *const libc::c_char,
    pub buffer: libc::c_uint,
    pub period: libc::c_uint,
    pub track_started: bool,
    pub write_cb: Option<unsafe extern "C" fn(_: frames_t, _: bool, _: s32_t,
                                              _: s32_t, _: s32_t, _: s32_t,
                                              _: *mut *mut s32_t)
                             -> libc::c_int>,
    pub start_frames: libc::c_uint,
    pub frames_played: libc::c_uint,
    pub frames_played_dmp: libc::c_uint,
    pub current_sample_rate: libc::c_uint,
    pub supported_rates: [libc::c_uint; 18],
    pub default_sample_rate: libc::c_uint,
    pub error_opening: bool,
    pub device_frames: libc::c_uint,
    pub updated: u32_t,
    pub track_start_time: u32_t,
    pub current_replay_gain: u32_t,
    pub c2rust_unnamed: C2RustUnnamed,
    pub next_sample_rate: libc::c_uint,
    pub track_start: *mut u8_t,
    pub gainL: u32_t,
    pub gainR: u32_t,
    pub invert: bool,
    pub next_replay_gain: u32_t,
    pub threshold: libc::c_uint,
    pub fade: fade_state,
    pub fade_start: *mut u8_t,
    pub fade_end: *mut u8_t,
    pub fade_dir: fade_dir,
    pub fade_mode: fade_mode,
    pub fade_secs: libc::c_uint,
    pub rate_delay: libc::c_uint,
    pub delay_active: bool,
    pub stop_time: u32_t,
    pub idle_to: u32_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed {
    pub pause_frames: u32_t,
    pub skip_frames: u32_t,
    pub start_at: u32_t,
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
// Common output function
static mut loglevel: log_level = lERROR;
#[no_mangle]
pub static mut output: outputstate =
    outputstate{state: OUTPUT_STOPPED,
                format: S32_LE,
                device: 0 as *const libc::c_char,
                buffer: 0,
                period: 0,
                track_started: false,
                write_cb: None,
                start_frames: 0,
                frames_played: 0,
                frames_played_dmp: 0,
                current_sample_rate: 0,
                supported_rates: [0; 18],
                default_sample_rate: 0,
                error_opening: false,
                device_frames: 0,
                updated: 0,
                track_start_time: 0,
                current_replay_gain: 0,
                c2rust_unnamed: C2RustUnnamed{pause_frames: 0,},
                next_sample_rate: 0,
                track_start: 0 as *const u8_t as *mut u8_t,
                gainL: 0,
                gainR: 0,
                invert: false,
                next_replay_gain: 0,
                threshold: 0,
                fade: FADE_INACTIVE,
                fade_start: 0 as *const u8_t as *mut u8_t,
                fade_end: 0 as *const u8_t as *mut u8_t,
                fade_dir: 0 as fade_dir,
                fade_mode: FADE_NONE,
                fade_secs: 0,
                rate_delay: 0,
                delay_active: false,
                stop_time: 0,
                idle_to: 0,};
static mut buf: buffer =
    buffer{buf: 0 as *const u8_t as *mut u8_t,
           readp: 0 as *const u8_t as *mut u8_t,
           writep: 0 as *const u8_t as *mut u8_t,
           wrap: 0 as *const u8_t as *mut u8_t,
           size: 0,
           base_size: 0,
           mutex:
               pthread_mutex_t{__data:
                                   __pthread_mutex_s{__lock: 0,
                                                     __count: 0,
                                                     __owner: 0,
                                                     __nusers: 0,
                                                     __kind: 0,
                                                     __spins: 0,
                                                     __elision: 0,
                                                     __list:
                                                         __pthread_list_t{__prev:
                                                                              0
                                                                                  as
                                                                                  *const __pthread_internal_list
                                                                                  as
                                                                                  *mut __pthread_internal_list,
                                                                          __next:
                                                                              0
                                                                                  as
                                                                                  *const __pthread_internal_list
                                                                                  as
                                                                                  *mut __pthread_internal_list,},},},};
#[no_mangle]
pub static mut outputbuf: *mut buffer =
    unsafe { &buf as *const buffer as *mut buffer };
#[no_mangle]
pub static mut silencebuf: *mut u8_t = 0 as *const u8_t as *mut u8_t;
#[no_mangle]
pub static mut user_rates: bool = 0 as libc::c_int != 0;
// functions starting _* are called with mutex locked
#[no_mangle]
pub unsafe extern "C" fn _output_frames(mut avail: frames_t) -> frames_t {
    let mut frames: frames_t = 0;
    let mut size: frames_t = 0;
    let mut silence: bool = false;
    let mut cross_gain_in: s32_t = 0 as libc::c_int;
    let mut cross_gain_out: s32_t = 0 as libc::c_int;
    let mut cross_ptr: *mut s32_t = 0 as *mut s32_t;
    let mut gainL: s32_t =
        if output.current_replay_gain != 0 {
            gain(output.gainL as s32_t, output.current_replay_gain as s32_t)
                as libc::c_uint
        } else { output.gainL } as s32_t;
    let mut gainR: s32_t =
        if output.current_replay_gain != 0 {
            gain(output.gainR as s32_t, output.current_replay_gain as s32_t)
                as libc::c_uint
        } else { output.gainR } as s32_t;
    if output.invert { gainL = -gainL; gainR = -gainR }
    frames =
        _buf_used(outputbuf).wrapping_div(8 as libc::c_int as libc::c_uint);
    silence = 0 as libc::c_int != 0;
    // start when threshold met
    if output.state as libc::c_int == OUTPUT_BUFFER as libc::c_int &&
           frames >
               output.threshold.wrapping_mul(output.next_sample_rate).wrapping_div(10
                                                                                       as
                                                                                       libc::c_int
                                                                                       as
                                                                                       libc::c_uint)
           && frames > output.start_frames {
        output.state = OUTPUT_RUNNING;
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d start buffer frames: %u\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 15],
                                               &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                     64 as libc::c_int, frames);
        }
        wake_controller();
    }
    // skip ahead - consume outputbuf but play nothing
    if output.state as libc::c_int == OUTPUT_SKIP_FRAMES as libc::c_int {
        if frames > 0 as libc::c_int as libc::c_uint {
            let mut skip: frames_t =
                if frames < output.c2rust_unnamed.skip_frames {
                    frames
                } else { output.c2rust_unnamed.skip_frames };
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d skip %u of %u frames\n\x00" as *const u8
                             as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 15],
                                                   &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                         72 as libc::c_int, skip,
                         output.c2rust_unnamed.skip_frames);
            }
            frames =
                (frames as libc::c_uint).wrapping_sub(skip) as frames_t as
                    frames_t;
            output.frames_played = output.frames_played.wrapping_add(skip);
            while skip > 0 as libc::c_int as libc::c_uint {
                let mut cont_frames: frames_t =
                    if skip <
                           _buf_cont_read(outputbuf).wrapping_div(8 as
                                                                      libc::c_int
                                                                      as
                                                                      libc::c_uint)
                       {
                        skip
                    } else {
                        _buf_cont_read(outputbuf).wrapping_div(8 as
                                                                   libc::c_int
                                                                   as
                                                                   libc::c_uint)
                    };
                skip =
                    (skip as libc::c_uint).wrapping_sub(cont_frames) as
                        frames_t as frames_t;
                _buf_inc_readp(outputbuf,
                               cont_frames.wrapping_mul(8 as libc::c_int as
                                                            libc::c_uint));
            }
        }
        output.state = OUTPUT_RUNNING
    }
    // pause frames - play silence for required frames
    if output.state as libc::c_int == OUTPUT_PAUSE_FRAMES as libc::c_int {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d pause %u frames\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 15],
                                               &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                     86 as libc::c_int, output.c2rust_unnamed.pause_frames);
        }
        if output.c2rust_unnamed.pause_frames ==
               0 as libc::c_int as libc::c_uint {
            output.state = OUTPUT_RUNNING
        } else {
            silence = 1 as libc::c_int != 0;
            frames =
                if avail < output.c2rust_unnamed.pause_frames {
                    avail
                } else { output.c2rust_unnamed.pause_frames };
            frames =
                if frames < 2048 as libc::c_int as libc::c_uint {
                    frames
                } else { 2048 as libc::c_int as libc::c_uint };
            output.c2rust_unnamed.pause_frames =
                (output.c2rust_unnamed.pause_frames as
                     libc::c_uint).wrapping_sub(frames) as u32_t as u32_t
        }
    }
    // start at - play silence until jiffies reached
    if output.state as libc::c_int == OUTPUT_START_AT as libc::c_int {
        let mut now: u32_t = gettime_ms();
        if now >= output.c2rust_unnamed.start_at ||
               output.c2rust_unnamed.start_at >
                   now.wrapping_add(10000 as libc::c_int as libc::c_uint) {
            output.state = OUTPUT_RUNNING
        } else {
            let mut delta_frames: u32_t =
                output.c2rust_unnamed.start_at.wrapping_sub(now).wrapping_mul(output.current_sample_rate).wrapping_div(1000
                                                                                                                           as
                                                                                                                           libc::c_int
                                                                                                                           as
                                                                                                                           libc::c_uint);
            silence = 1 as libc::c_int != 0;
            frames = if avail < delta_frames { avail } else { delta_frames };
            frames =
                if frames < 2048 as libc::c_int as libc::c_uint {
                    frames
                } else { 2048 as libc::c_int as libc::c_uint }
        }
    }
    // play silence if buffering or no frames
    if output.state as libc::c_int <= OUTPUT_BUFFER as libc::c_int ||
           frames == 0 as libc::c_int as libc::c_uint {
        silence = 1 as libc::c_int != 0;
        frames =
            if avail < 2048 as libc::c_int as libc::c_uint {
                avail
            } else { 2048 as libc::c_int as libc::c_uint }
    }
    if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d avail: %d frames: %d silence: %d\n\x00" as
                     *const u8 as *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 15],
                                           &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                 116 as libc::c_int, avail, frames, silence as libc::c_int);
    }
    frames = if frames < avail { frames } else { avail };
    size = frames;
    while size > 0 as libc::c_int as libc::c_uint {
        let mut out_frames: frames_t = 0;
        let mut cont_frames_0: frames_t =
            _buf_cont_read(outputbuf).wrapping_div(8 as libc::c_int as
                                                       libc::c_uint);
        let mut wrote: libc::c_int = 0;
        if !output.track_start.is_null() && !silence {
            if output.track_start == (*outputbuf).readp {
                let mut delay: libc::c_uint =
                    0 as libc::c_int as libc::c_uint;
                if output.current_sample_rate != output.next_sample_rate {
                    delay = output.rate_delay
                }
                frames =
                    (frames as libc::c_uint).wrapping_sub(size) as frames_t as
                        frames_t;
                // add silence delay in two halves, before and after track start on rate or pcm-dop change
                if delay != 0 {
                    output.state =
                        OUTPUT_PAUSE_FRAMES; // first delay - don't process track start
                    if !output.delay_active {
                        output.c2rust_unnamed.pause_frames =
                            output.current_sample_rate.wrapping_mul(delay).wrapping_div(2000
                                                                                            as
                                                                                            libc::c_int
                                                                                            as
                                                                                            libc::c_uint);
                        output.delay_active = 1 as libc::c_int != 0;
                        break ;
                    } else {
                        output.c2rust_unnamed.pause_frames =
                            output.next_sample_rate.wrapping_mul(delay).wrapping_div(2000
                                                                                         as
                                                                                         libc::c_int
                                                                                         as
                                                                                         libc::c_uint);
                        output.delay_active = 0 as libc::c_int != 0
                        // second delay - process track start
                    }
                }
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d track start sample rate: %u replay_gain: %u\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 15],
                                                       &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                             149 as libc::c_int, output.next_sample_rate,
                             output.next_replay_gain);
                }
                output.frames_played = 0 as libc::c_int as libc::c_uint;
                output.track_started = 1 as libc::c_int != 0;
                output.track_start_time = gettime_ms();
                output.current_sample_rate = output.next_sample_rate;
                if output.fade as libc::c_uint ==
                       FADE_INACTIVE as libc::c_int as libc::c_uint ||
                       output.fade_mode as libc::c_uint !=
                           FADE_CROSSFADE as libc::c_int as libc::c_uint {
                    output.current_replay_gain = output.next_replay_gain
                }
                output.track_start = 0 as *mut u8_t;
                break ;
            } else if output.track_start > (*outputbuf).readp {
                // reduce cont_frames so we find the next track start at beginning of next chunk
                cont_frames_0 =
                    if (cont_frames_0 as libc::c_long) <
                           output.track_start.wrapping_offset_from((*outputbuf).readp)
                               as libc::c_long /
                               8 as libc::c_int as libc::c_long {
                        cont_frames_0 as libc::c_long
                    } else {
                        (output.track_start.wrapping_offset_from((*outputbuf).readp)
                             as libc::c_long) /
                            8 as libc::c_int as libc::c_long
                    } as frames_t
            }
        }
        if output.fade as libc::c_uint != 0 && !silence {
            if output.fade as libc::c_uint ==
                   FADE_DUE as libc::c_int as libc::c_uint {
                if output.fade_start == (*outputbuf).readp {
                    if loglevel as libc::c_uint >=
                           lINFO as libc::c_int as libc::c_uint {
                        logprint(b"%s %s:%d fade start reached\n\x00" as
                                     *const u8 as *const libc::c_char,
                                 logtime(),
                                 (*::std::mem::transmute::<&[u8; 15],
                                                           &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                                 177 as libc::c_int);
                    }
                    output.fade = FADE_ACTIVE
                } else if output.fade_start > (*outputbuf).readp {
                    cont_frames_0 =
                        if (cont_frames_0 as libc::c_long) <
                               output.fade_start.wrapping_offset_from((*outputbuf).readp)
                                   as libc::c_long /
                                   8 as libc::c_int as libc::c_long {
                            cont_frames_0 as libc::c_long
                        } else {
                            (output.fade_start.wrapping_offset_from((*outputbuf).readp)
                                 as libc::c_long) /
                                8 as libc::c_int as libc::c_long
                        } as frames_t
                }
            }
            if output.fade as libc::c_uint ==
                   FADE_ACTIVE as libc::c_int as libc::c_uint {
                // find position within fade
                let mut cur_f: frames_t =
                    if (*outputbuf).readp >= output.fade_start {
                        ((*outputbuf).readp.wrapping_offset_from(output.fade_start)
                             as libc::c_long) /
                            8 as libc::c_int as libc::c_long
                    } else {
                        ((*outputbuf).readp.offset((*outputbuf).size as
                                                       isize).wrapping_offset_from(output.fade_start)
                             as libc::c_long) /
                            8 as libc::c_int as libc::c_long
                    } as frames_t;
                let mut dur_f: frames_t =
                    if output.fade_end >= output.fade_start {
                        (output.fade_end.wrapping_offset_from(output.fade_start)
                             as libc::c_long) /
                            8 as libc::c_int as libc::c_long
                    } else {
                        (output.fade_end.offset((*outputbuf).size as
                                                    isize).wrapping_offset_from(output.fade_start)
                             as libc::c_long) /
                            8 as libc::c_int as libc::c_long
                    } as frames_t;
                if cur_f >= dur_f {
                    if output.fade_mode as libc::c_uint ==
                           FADE_INOUT as libc::c_int as libc::c_uint &&
                           output.fade_dir as libc::c_uint ==
                               FADE_DOWN as libc::c_int as libc::c_uint {
                        if loglevel as libc::c_uint >=
                               lINFO as libc::c_int as libc::c_uint {
                            logprint(b"%s %s:%d fade down complete, starting fade up\n\x00"
                                         as *const u8 as *const libc::c_char,
                                     logtime(),
                                     (*::std::mem::transmute::<&[u8; 15],
                                                               &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                                     191 as libc::c_int);
                        }
                        output.fade_dir = FADE_UP;
                        output.fade_start = (*outputbuf).readp;
                        output.fade_end =
                            (*outputbuf).readp.offset(dur_f.wrapping_mul(8 as
                                                                             libc::c_int
                                                                             as
                                                                             libc::c_uint)
                                                          as isize);
                        if output.fade_end >= (*outputbuf).wrap {
                            output.fade_end =
                                output.fade_end.offset(-((*outputbuf).size as
                                                             isize))
                        }
                        cur_f = 0 as libc::c_int as frames_t
                    } else if output.fade_mode as libc::c_uint ==
                                  FADE_CROSSFADE as libc::c_int as
                                      libc::c_uint {
                        if loglevel as libc::c_uint >=
                               lINFO as libc::c_int as libc::c_uint {
                            logprint(b"%s %s:%d crossfade complete\n\x00" as
                                         *const u8 as *const libc::c_char,
                                     logtime(),
                                     (*::std::mem::transmute::<&[u8; 15],
                                                               &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                                     200 as libc::c_int);
                        }
                        if _buf_used(outputbuf) >=
                               dur_f.wrapping_mul(8 as libc::c_int as
                                                      libc::c_uint) {
                            _buf_inc_readp(outputbuf,
                                           dur_f.wrapping_mul(8 as libc::c_int
                                                                  as
                                                                  libc::c_uint));
                            if loglevel as libc::c_uint >=
                                   lINFO as libc::c_int as libc::c_uint {
                                logprint(b"%s %s:%d skipped crossfaded start\n\x00"
                                             as *const u8 as
                                             *const libc::c_char, logtime(),
                                         (*::std::mem::transmute::<&[u8; 15],
                                                                   &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                                         203 as libc::c_int);
                            }
                        } else if loglevel as libc::c_uint >=
                                      lWARN as libc::c_int as libc::c_uint {
                            logprint(b"%s %s:%d unable to skip crossfaded start\n\x00"
                                         as *const u8 as *const libc::c_char,
                                     logtime(),
                                     (*::std::mem::transmute::<&[u8; 15],
                                                               &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                                     205 as libc::c_int);
                        }
                        output.fade = FADE_INACTIVE;
                        output.current_replay_gain = output.next_replay_gain
                    } else {
                        if loglevel as libc::c_uint >=
                               lINFO as libc::c_int as libc::c_uint {
                            logprint(b"%s %s:%d fade complete\n\x00" as
                                         *const u8 as *const libc::c_char,
                                     logtime(),
                                     (*::std::mem::transmute::<&[u8; 15],
                                                               &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                                     210 as libc::c_int);
                        }
                        output.fade = FADE_INACTIVE
                    }
                }
                // if fade in progress set fade gain, ensure cont_frames reduced so we get to end of fade at start of chunk
                if output.fade as u64 != 0 {
                    if output.fade_end > (*outputbuf).readp {
                        cont_frames_0 =
                            if (cont_frames_0 as libc::c_long) <
                                   output.fade_end.wrapping_offset_from((*outputbuf).readp)
                                       as libc::c_long /
                                       8 as libc::c_int as libc::c_long {
                                cont_frames_0 as libc::c_long
                            } else {
                                (output.fade_end.wrapping_offset_from((*outputbuf).readp)
                                     as libc::c_long) /
                                    8 as libc::c_int as libc::c_long
                            } as frames_t
                    }
                    if output.fade_dir as libc::c_uint ==
                           FADE_UP as libc::c_int as libc::c_uint ||
                           output.fade_dir as libc::c_uint ==
                               FADE_DOWN as libc::c_int as libc::c_uint {
                        // fade in, in-out, out handled via altering standard gain
                        let mut fade_gain: s32_t = 0;
                        if output.fade_dir as libc::c_uint ==
                               FADE_DOWN as libc::c_int as libc::c_uint {
                            cur_f = dur_f.wrapping_sub(cur_f)
                        }
                        fade_gain =
                            to_gain(cur_f as libc::c_float /
                                        dur_f as libc::c_float);
                        gainL = gain(gainL, fade_gain);
                        gainR = gain(gainR, fade_gain);
                        if output.invert { gainL = -gainL; gainR = -gainR }
                    }
                    if output.fade_dir as libc::c_uint ==
                           FADE_CROSS as libc::c_int as libc::c_uint {
                        // cross fade requires special treatment - performed later based on these values
						// support different replay gain for old and new track by retaining old value until crossfade completes
                        if _buf_used(outputbuf).wrapping_div(8 as libc::c_int
                                                                 as
                                                                 libc::c_uint)
                               > dur_f.wrapping_add(size) {
                            cross_gain_in =
                                to_gain(cur_f as libc::c_float /
                                            dur_f as libc::c_float);
                            cross_gain_out =
                                0x10000 as libc::c_int - cross_gain_in;
                            if output.current_replay_gain != 0 {
                                cross_gain_out =
                                    gain(cross_gain_out,
                                         output.current_replay_gain as s32_t)
                            }
                            if output.next_replay_gain != 0 {
                                cross_gain_in =
                                    gain(cross_gain_in,
                                         output.next_replay_gain as s32_t)
                            }
                            gainL = output.gainL as s32_t;
                            gainR = output.gainR as s32_t;
                            if output.invert {
                                gainL = -gainL;
                                gainR = -gainR
                            }
                            cross_ptr =
                                output.fade_end.offset(cur_f.wrapping_mul(8 as
                                                                              libc::c_int
                                                                              as
                                                                              libc::c_uint)
                                                           as isize) as
                                    *mut s32_t
                        } else {
                            if loglevel as libc::c_uint >=
                                   lINFO as libc::c_int as libc::c_uint {
                                logprint(b"%s %s:%d unable to continue crossfade - too few samples\n\x00"
                                             as *const u8 as
                                             *const libc::c_char, logtime(),
                                         (*::std::mem::transmute::<&[u8; 15],
                                                                   &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                                         247 as libc::c_int);
                            }
                            output.fade = FADE_INACTIVE
                        }
                    }
                }
            }
        }
        out_frames =
            if !silence {
                if size < cont_frames_0 { size } else { cont_frames_0 }
            } else { size };
        wrote =
            output.write_cb.expect("non-null function pointer")(out_frames,
                                                                silence,
                                                                gainL, gainR,
                                                                cross_gain_in,
                                                                cross_gain_out,
                                                                &mut cross_ptr);
        if wrote <= 0 as libc::c_int {
            frames =
                (frames as libc::c_uint).wrapping_sub(size) as frames_t as
                    frames_t;
            break ;
        } else {
            out_frames = wrote as frames_t;
            size =
                (size as libc::c_uint).wrapping_sub(out_frames) as frames_t as
                    frames_t;
            if !silence {
                _buf_inc_readp(outputbuf,
                               out_frames.wrapping_mul(8 as libc::c_int as
                                                           libc::c_uint));
                output.frames_played =
                    output.frames_played.wrapping_add(out_frames)
            }
        }
    }
    if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d wrote %u frames\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 15],
                                           &[libc::c_char; 15]>(b"_output_frames\x00")).as_ptr(),
                 276 as libc::c_int, frames);
    }
    return frames;
}
// _* called with mutex locked
#[no_mangle]
pub unsafe extern "C" fn _checkfade(mut start: bool) {
    let mut bytes: frames_t = 0;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d fade mode: %u duration: %u %s\n\x00" as *const u8
                     as *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 11],
                                           &[libc::c_char; 11]>(b"_checkfade\x00")).as_ptr(),
                 284 as libc::c_int, output.fade_mode as libc::c_uint,
                 output.fade_secs,
                 if start as libc::c_int != 0 {
                     b"track-start\x00" as *const u8 as *const libc::c_char
                 } else {
                     b"track-end\x00" as *const u8 as *const libc::c_char
                 });
    }
    bytes =
        output.next_sample_rate.wrapping_mul(8 as libc::c_int as
                                                 libc::c_uint).wrapping_mul(output.fade_secs);
    if output.fade_mode as libc::c_uint ==
           FADE_INOUT as libc::c_int as libc::c_uint {
        /* align on a frame boundary */
        bytes =
            bytes.wrapping_div(2 as libc::c_int as
                                   libc::c_uint).wrapping_div(8 as libc::c_int
                                                                  as
                                                                  libc::c_uint).wrapping_mul(8
                                                                                                 as
                                                                                                 libc::c_int
                                                                                                 as
                                                                                                 libc::c_uint)
    } // shorter than full buffer otherwise start and end align
    if start as libc::c_int != 0 &&
           (output.fade_mode as libc::c_uint ==
                FADE_IN as libc::c_int as libc::c_uint ||
                output.fade_mode as libc::c_uint ==
                    FADE_INOUT as libc::c_int as libc::c_uint &&
                    _buf_used(outputbuf) == 0 as libc::c_int as libc::c_uint)
       {
        bytes =
            if (bytes as libc::c_ulong) <
                   (*outputbuf).size.wrapping_sub(8 as libc::c_int as
                                                      libc::c_ulong) {
                bytes as libc::c_ulong
            } else {
                (*outputbuf).size.wrapping_sub(8 as libc::c_int as
                                                   libc::c_ulong)
            } as
                frames_t; // max of current remaining samples from previous track
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d fade IN: %u frames\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 11],
                                               &[libc::c_char; 11]>(b"_checkfade\x00")).as_ptr(),
                     294 as libc::c_int,
                     bytes.wrapping_div(8 as libc::c_int as
                                            libc::c_uint)); // max of 90% of outputbuf as we consume additional buffer during crossfade
        }
        output.fade = FADE_DUE;
        output.fade_dir = FADE_UP;
        output.fade_start = (*outputbuf).writep;
        output.fade_end = output.fade_start.offset(bytes as isize);
        if output.fade_end >= (*outputbuf).wrap {
            output.fade_end =
                output.fade_end.offset(-((*outputbuf).size as isize))
        }
    }
    if !start &&
           (output.fade_mode as libc::c_uint ==
                FADE_OUT as libc::c_int as libc::c_uint ||
                output.fade_mode as libc::c_uint ==
                    FADE_INOUT as libc::c_int as libc::c_uint) {
        bytes =
            if _buf_used(outputbuf) < bytes {
                _buf_used(outputbuf)
            } else { bytes };
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d fade %s: %u frames\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 11],
                                               &[libc::c_char; 11]>(b"_checkfade\x00")).as_ptr(),
                     306 as libc::c_int,
                     if output.fade_mode as libc::c_uint ==
                            FADE_INOUT as libc::c_int as libc::c_uint {
                         b"IN-OUT\x00" as *const u8 as *const libc::c_char
                     } else {
                         b"OUT\x00" as *const u8 as *const libc::c_char
                     }, bytes.wrapping_div(8 as libc::c_int as libc::c_uint));
        }
        output.fade = FADE_DUE;
        output.fade_dir = FADE_DOWN;
        output.fade_start = (*outputbuf).writep.offset(-(bytes as isize));
        if output.fade_start < (*outputbuf).buf {
            output.fade_start =
                output.fade_start.offset((*outputbuf).size as isize)
        }
        output.fade_end = (*outputbuf).writep
    }
    if start as libc::c_int != 0 &&
           output.fade_mode as libc::c_uint ==
               FADE_CROSSFADE as libc::c_int as libc::c_uint {
        if _buf_used(outputbuf) != 0 as libc::c_int as libc::c_uint {
            if output.next_sample_rate != output.current_sample_rate {
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d crossfade disabled as sample rates differ\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 11],
                                                       &[libc::c_char; 11]>(b"_checkfade\x00")).as_ptr(),
                             319 as libc::c_int);
                }
                return
            }
            bytes =
                if bytes < _buf_used(outputbuf) {
                    bytes
                } else { _buf_used(outputbuf) };
            bytes =
                if bytes <
                       ((*outputbuf).size as libc::c_double * 0.9f64) as
                           frames_t {
                    bytes
                } else {
                    ((*outputbuf).size as libc::c_double * 0.9f64) as frames_t
                };
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d CROSSFADE: %u frames\n\x00" as *const u8
                             as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 11],
                                                   &[libc::c_char; 11]>(b"_checkfade\x00")).as_ptr(),
                         324 as libc::c_int,
                         bytes.wrapping_div(8 as libc::c_int as
                                                libc::c_uint));
            }
            output.fade = FADE_DUE;
            output.fade_dir = FADE_CROSS;
            output.fade_start = (*outputbuf).writep.offset(-(bytes as isize));
            if output.fade_start < (*outputbuf).buf {
                output.fade_start =
                    output.fade_start.offset((*outputbuf).size as isize)
            }
            output.fade_end = (*outputbuf).writep;
            output.track_start = output.fade_start
        } else if (*outputbuf).size ==
                      (44100 as libc::c_int * 8 as libc::c_int *
                           10 as libc::c_int) as libc::c_ulong &&
                      (*outputbuf).readp == (*outputbuf).buf {
            // if default setting used and nothing in buffer attempt to resize to provide full crossfade support
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d resize outputbuf for crossfade\n\x00" as
                             *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 11],
                                                   &[libc::c_char; 11]>(b"_checkfade\x00")).as_ptr(),
                         335 as libc::c_int);
            }
            _buf_resize(outputbuf,
                        (44100 as libc::c_int * 8 as libc::c_int *
                             10 as libc::c_int * 12 as libc::c_int /
                             10 as libc::c_int) as size_t);
            touch_memory((*outputbuf).buf, (*outputbuf).size);
        }
    };
}
#[no_mangle]
pub unsafe extern "C" fn output_init_common(mut level: log_level,
                                            mut device: *const libc::c_char,
                                            mut output_buf_size: libc::c_uint,
                                            mut rates: *mut libc::c_uint,
                                            mut idle: libc::c_uint) {
    let mut i: libc::c_uint = 0;
    loglevel = level;
    output_buf_size =
        output_buf_size.wrapping_sub(output_buf_size.wrapping_rem(8 as
                                                                      libc::c_int
                                                                      as
                                                                      libc::c_uint));
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d outputbuf size: %u\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 19],
                                           &[libc::c_char; 19]>(b"output_init_common\x00")).as_ptr(),
                 350 as libc::c_int, output_buf_size);
    }
    buf_init(outputbuf, output_buf_size as size_t);
    if (*outputbuf).buf.is_null() {
        logprint(b"%s %s:%d unable to malloc output buffer\n\x00" as *const u8
                     as *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 19],
                                           &[libc::c_char; 19]>(b"output_init_common\x00")).as_ptr(),
                 354 as libc::c_int);
        exit(0 as libc::c_int);
    }
    silencebuf =
        malloc((2048 as libc::c_int * 8 as libc::c_int) as libc::c_ulong) as
            *mut u8_t;
    if silencebuf.is_null() {
        logprint(b"%s %s:%d unable to malloc silence buffer\n\x00" as
                     *const u8 as *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 19],
                                           &[libc::c_char; 19]>(b"output_init_common\x00")).as_ptr(),
                 360 as libc::c_int);
        exit(0 as libc::c_int);
    }
    memset(silencebuf as *mut libc::c_void, 0 as libc::c_int,
           (2048 as libc::c_int * 8 as libc::c_int) as libc::c_ulong);
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d idle timeout: %u\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 19],
                                           &[libc::c_char; 19]>(b"output_init_common\x00")).as_ptr(),
                 374 as libc::c_int, idle);
    }
    output.state =
        if idle != 0 {
            OUTPUT_OFF as libc::c_int
        } else { OUTPUT_STOPPED as libc::c_int } as output_state;
    output.device = device;
    output.fade = FADE_INACTIVE;
    output.invert = 0 as libc::c_int != 0;
    output.error_opening = 0 as libc::c_int != 0;
    output.idle_to = idle;
    /* Skip test_open for stdout, set default sample rates */
    if *output.device.offset(0 as libc::c_int as isize) as libc::c_int ==
           '-' as i32 {
        i = 0 as libc::c_int as libc::c_uint;
        while i < 18 as libc::c_int as libc::c_uint {
            output.supported_rates[i as usize] = *rates.offset(i as isize);
            i = i.wrapping_add(1)
        }
    } else if !test_open(output.device, output.supported_rates.as_mut_ptr(),
                         user_rates) {
        logprint(b"%s %s:%d unable to open output device: %s\n\x00" as
                     *const u8 as *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 19],
                                           &[libc::c_char; 19]>(b"output_init_common\x00")).as_ptr(),
                 391 as libc::c_int, output.device);
        exit(0 as libc::c_int);
    }
    if user_rates {
        i = 0 as libc::c_int as libc::c_uint;
        while i < 18 as libc::c_int as libc::c_uint {
            output.supported_rates[i as usize] = *rates.offset(i as isize);
            i = i.wrapping_add(1)
        }
    }
    // set initial sample rate, preferring 44100
    i = 0 as libc::c_int as libc::c_uint;
    while i < 18 as libc::c_int as libc::c_uint {
        if output.supported_rates[i as usize] ==
               44100 as libc::c_int as libc::c_uint {
            output.default_sample_rate = 44100 as libc::c_int as libc::c_uint;
            break ;
        } else { i = i.wrapping_add(1) }
    }
    if output.default_sample_rate == 0 {
        output.default_sample_rate =
            output.supported_rates[0 as libc::c_int as usize]
    }
    output.current_sample_rate = output.default_sample_rate;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        let mut rates_buf: [libc::c_char; 180] =
            *::std::mem::transmute::<&[u8; 180],
                                     &mut [libc::c_char; 180]>(b"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00");
        i = 0 as libc::c_int as libc::c_uint;
        while output.supported_rates[i as usize] != 0 {
            let mut s: [libc::c_char; 10] = [0; 10];
            sprintf(s.as_mut_ptr(),
                    b"%d \x00" as *const u8 as *const libc::c_char,
                    output.supported_rates[i as usize]);
            strcat(rates_buf.as_mut_ptr(), s.as_mut_ptr());
            i = i.wrapping_add(1)
        }
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d supported rates: %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 19],
                                               &[libc::c_char; 19]>(b"output_init_common\x00")).as_ptr(),
                     422 as libc::c_int, rates_buf.as_mut_ptr());
        }
    };
}
#[no_mangle]
pub unsafe extern "C" fn output_close_common() {
    buf_destroy(outputbuf);
    free(silencebuf as *mut libc::c_void);
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
// output.c output_alsa.c output_pa.c output_pack.c
// frames played at the point delay is measured
// ordered largest first so [0] is max_rate
// set in decode thread
// set in decode thread
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
#[no_mangle]
pub unsafe extern "C" fn output_flush() {
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d flush output buffer\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"output_flush\x00")).as_ptr(),
                 435 as libc::c_int);
    }
    buf_flush(outputbuf);
    pthread_mutex_lock(&mut (*outputbuf).mutex);
    output.fade = FADE_INACTIVE;
    if output.state as libc::c_int != OUTPUT_OFF as libc::c_int {
        output.state = OUTPUT_STOPPED;
        if output.error_opening {
            output.current_sample_rate = output.default_sample_rate
        }
        output.delay_active = 0 as libc::c_int != 0
    }
    output.frames_played = 0 as libc::c_int as libc::c_uint;
    pthread_mutex_unlock(&mut (*outputbuf).mutex);
}
