use ::libc;
extern "C" {
    #[no_mangle]
    fn close(__fd: libc::c_int) -> libc::c_int;
    #[no_mangle]
    fn read(__fd: libc::c_int, __buf: *mut libc::c_void, __nbytes: size_t)
     -> ssize_t;
    #[no_mangle]
    fn usleep(__useconds: __useconds_t) -> libc::c_int;
    #[no_mangle]
    fn malloc(_: libc::c_ulong) -> *mut libc::c_void;
    #[no_mangle]
    fn free(__ptr: *mut libc::c_void);
    #[no_mangle]
    fn memcpy(_: *mut libc::c_void, _: *const libc::c_void, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn memset(_: *mut libc::c_void, _: libc::c_int, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn strerror(_: libc::c_int) -> *mut libc::c_char;
    #[no_mangle]
    fn __errno_location() -> *mut libc::c_int;
    #[no_mangle]
    fn socket(__domain: libc::c_int, __type: libc::c_int,
              __protocol: libc::c_int) -> libc::c_int;
    #[no_mangle]
    fn send(__fd: libc::c_int, __buf: *const libc::c_void, __n: size_t,
            __flags: libc::c_int) -> ssize_t;
    #[no_mangle]
    fn recv(__fd: libc::c_int, __buf: *mut libc::c_void, __n: size_t,
            __flags: libc::c_int) -> ssize_t;
    #[no_mangle]
    fn ntohs(__netshort: uint16_t) -> uint16_t;
    #[no_mangle]
    fn inet_ntoa(__in: in_addr) -> *mut libc::c_char;
    #[no_mangle]
    fn poll(__fds: *mut pollfd, __nfds: nfds_t, __timeout: libc::c_int)
     -> libc::c_int;
    #[no_mangle]
    fn pthread_create(__newthread: *mut pthread_t,
                      __attr: *const pthread_attr_t,
                      __start_routine:
                          Option<unsafe extern "C" fn(_: *mut libc::c_void)
                                     -> *mut libc::c_void>,
                      __arg: *mut libc::c_void) -> libc::c_int;
    #[no_mangle]
    fn pthread_join(__th: pthread_t, __thread_return: *mut *mut libc::c_void)
     -> libc::c_int;
    #[no_mangle]
    fn pthread_attr_init(__attr: *mut pthread_attr_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_attr_destroy(__attr: *mut pthread_attr_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_attr_setstacksize(__attr: *mut pthread_attr_t,
                                 __stacksize: size_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_lock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_unlock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn logtime() -> *const libc::c_char;
    #[no_mangle]
    fn logprint(fmt: *const libc::c_char, _: ...);
    #[no_mangle]
    fn set_nonblock(s: sockfd);
    #[no_mangle]
    fn connect_timeout(sock: sockfd, addr: *const sockaddr,
                       addrlen: socklen_t, timeout: libc::c_int)
     -> libc::c_int;
    #[no_mangle]
    fn touch_memory(buf_0: *mut u8_t, size: size_t);
    #[no_mangle]
    fn _buf_space(buf_0: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_cont_write(buf_0: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_inc_writep(buf_0: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn buf_flush(buf_0: *mut buffer);
    #[no_mangle]
    fn buf_init(buf_0: *mut buffer, size: size_t);
    #[no_mangle]
    fn buf_destroy(buf_0: *mut buffer);
    #[no_mangle]
    fn wake_controller();
    #[no_mangle]
    fn exit(_: libc::c_int) -> !;
    #[no_mangle]
    fn open(__file: *const libc::c_char, __oflag: libc::c_int, _: ...)
     -> libc::c_int;
}
pub type size_t = libc::c_ulong;
pub type __uint8_t = libc::c_uchar;
pub type __uint16_t = libc::c_ushort;
pub type __uint32_t = libc::c_uint;
pub type __uint64_t = libc::c_ulong;
pub type __useconds_t = libc::c_uint;
pub type __ssize_t = libc::c_long;
pub type __socklen_t = libc::c_uint;
pub type ssize_t = __ssize_t;
pub type u_int8_t = __uint8_t;
pub type u_int16_t = __uint16_t;
pub type u_int32_t = __uint32_t;
pub type u_int64_t = __uint64_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_internal_list {
    pub __prev: *mut __pthread_internal_list,
    pub __next: *mut __pthread_internal_list,
}
pub type __pthread_list_t = __pthread_internal_list;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_mutex_s {
    pub __lock: libc::c_int,
    pub __count: libc::c_uint,
    pub __owner: libc::c_int,
    pub __nusers: libc::c_uint,
    pub __kind: libc::c_int,
    pub __spins: libc::c_short,
    pub __elision: libc::c_short,
    pub __list: __pthread_list_t,
}
pub type pthread_t = libc::c_ulong;
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_attr_t {
    pub __size: [libc::c_char; 56],
    pub __align: libc::c_long,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_mutex_t {
    pub __data: __pthread_mutex_s,
    pub __size: [libc::c_char; 40],
    pub __align: libc::c_long,
}
pub type socklen_t = __socklen_t;
pub type uint16_t = __uint16_t;
pub type uint32_t = __uint32_t;
pub type __socket_type = libc::c_uint;
pub const SOCK_NONBLOCK: __socket_type = 2048;
pub const SOCK_CLOEXEC: __socket_type = 524288;
pub const SOCK_PACKET: __socket_type = 10;
pub const SOCK_DCCP: __socket_type = 6;
pub const SOCK_SEQPACKET: __socket_type = 5;
pub const SOCK_RDM: __socket_type = 4;
pub const SOCK_RAW: __socket_type = 3;
pub const SOCK_DGRAM: __socket_type = 2;
pub const SOCK_STREAM: __socket_type = 1;
pub type sa_family_t = libc::c_ushort;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct sockaddr {
    pub sa_family: sa_family_t,
    pub sa_data: [libc::c_char; 14],
}
pub type C2RustUnnamed = libc::c_uint;
pub const MSG_CMSG_CLOEXEC: C2RustUnnamed = 1073741824;
pub const MSG_FASTOPEN: C2RustUnnamed = 536870912;
pub const MSG_ZEROCOPY: C2RustUnnamed = 67108864;
pub const MSG_BATCH: C2RustUnnamed = 262144;
pub const MSG_WAITFORONE: C2RustUnnamed = 65536;
pub const MSG_MORE: C2RustUnnamed = 32768;
pub const MSG_NOSIGNAL: C2RustUnnamed = 16384;
pub const MSG_ERRQUEUE: C2RustUnnamed = 8192;
pub const MSG_RST: C2RustUnnamed = 4096;
pub const MSG_CONFIRM: C2RustUnnamed = 2048;
pub const MSG_SYN: C2RustUnnamed = 1024;
pub const MSG_FIN: C2RustUnnamed = 512;
pub const MSG_WAITALL: C2RustUnnamed = 256;
pub const MSG_EOR: C2RustUnnamed = 128;
pub const MSG_DONTWAIT: C2RustUnnamed = 64;
pub const MSG_TRUNC: C2RustUnnamed = 32;
pub const MSG_PROXY: C2RustUnnamed = 16;
pub const MSG_CTRUNC: C2RustUnnamed = 8;
pub const MSG_TRYHARD: C2RustUnnamed = 4;
pub const MSG_DONTROUTE: C2RustUnnamed = 4;
pub const MSG_PEEK: C2RustUnnamed = 2;
pub const MSG_OOB: C2RustUnnamed = 1;
pub type in_port_t = uint16_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct sockaddr_in {
    pub sin_family: sa_family_t,
    pub sin_port: in_port_t,
    pub sin_addr: in_addr,
    pub sin_zero: [libc::c_uchar; 8],
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct in_addr {
    pub s_addr: in_addr_t,
}
pub type in_addr_t = uint32_t;
pub type nfds_t = libc::c_ulong;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct pollfd {
    pub fd: libc::c_int,
    pub events: libc::c_short,
    pub revents: libc::c_short,
}
pub type u8_t = u_int8_t;
pub type u16_t = u_int16_t;
pub type u32_t = u_int32_t;
pub type u64_t = u_int64_t;
pub type sockfd = libc::c_int;
pub type log_level = libc::c_uint;
pub const lSDEBUG: log_level = 4;
pub const lDEBUG: log_level = 3;
pub const lINFO: log_level = 2;
pub const lWARN: log_level = 1;
pub const lERROR: log_level = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct buffer {
    pub buf: *mut u8_t,
    pub readp: *mut u8_t,
    pub writep: *mut u8_t,
    pub wrap: *mut u8_t,
    pub size: size_t,
    pub base_size: size_t,
    pub mutex: pthread_mutex_t,
}
pub type stream_state = libc::c_uint;
pub const RECV_HEADERS: stream_state = 7;
pub const SEND_HEADERS: stream_state = 6;
pub const STREAMING_HTTP: stream_state = 5;
pub const STREAMING_FILE: stream_state = 4;
pub const STREAMING_BUFFERING: stream_state = 3;
pub const STREAMING_WAIT: stream_state = 2;
pub const DISCONNECT: stream_state = 1;
pub const STOPPED: stream_state = 0;
pub type disconnect_code = libc::c_uint;
pub const TIMEOUT: disconnect_code = 4;
pub const UNREACHABLE: disconnect_code = 3;
pub const REMOTE_DISCONNECT: disconnect_code = 2;
pub const LOCAL_DISCONNECT: disconnect_code = 1;
pub const DISCONNECT_OK: disconnect_code = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct streamstate {
    pub state: stream_state,
    pub disconnect: disconnect_code,
    pub header: *mut libc::c_char,
    pub header_len: size_t,
    pub sent_headers: bool,
    pub cont_wait: bool,
    pub bytes: u64_t,
    pub threshold: libc::c_uint,
    pub meta_interval: u32_t,
    pub meta_next: u32_t,
    pub meta_left: u32_t,
    pub meta_send: bool,
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
// stream thread
static mut loglevel: log_level = lERROR;
static mut buf: buffer =
    buffer{buf: 0 as *const u8_t as *mut u8_t,
           readp: 0 as *const u8_t as *mut u8_t,
           writep: 0 as *const u8_t as *mut u8_t,
           wrap: 0 as *const u8_t as *mut u8_t,
           size: 0,
           base_size: 0,
           mutex:
               pthread_mutex_t{__data:
                                   __pthread_mutex_s{__lock: 0,
                                                     __count: 0,
                                                     __owner: 0,
                                                     __nusers: 0,
                                                     __kind: 0,
                                                     __spins: 0,
                                                     __elision: 0,
                                                     __list:
                                                         __pthread_list_t{__prev:
                                                                              0
                                                                                  as
                                                                                  *const __pthread_internal_list
                                                                                  as
                                                                                  *mut __pthread_internal_list,
                                                                          __next:
                                                                              0
                                                                                  as
                                                                                  *const __pthread_internal_list
                                                                                  as
                                                                                  *mut __pthread_internal_list,},},},};
#[no_mangle]
pub static mut streambuf: *mut buffer =
    unsafe { &buf as *const buffer as *mut buffer };
static mut fd: sockfd = 0;
#[no_mangle]
pub static mut stream: streamstate =
    streamstate{state: STOPPED,
                disconnect: DISCONNECT_OK,
                header: 0 as *const libc::c_char as *mut libc::c_char,
                header_len: 0,
                sent_headers: false,
                cont_wait: false,
                bytes: 0,
                threshold: 0,
                meta_interval: 0,
                meta_next: 0,
                meta_left: 0,
                meta_send: false,};
unsafe extern "C" fn send_header() -> bool {
    let mut ptr: *mut libc::c_char = stream.header;
    let mut len: libc::c_int = stream.header_len as libc::c_int;
    let mut try_0: libc::c_uint = 0 as libc::c_int as libc::c_uint;
    let mut n: ssize_t = 0;
    while len != 0 {
        n =
            send(fd, ptr as *const libc::c_void, len as size_t,
                 MSG_NOSIGNAL as libc::c_int);
        if n <= 0 as libc::c_int as libc::c_long {
            if n < 0 as libc::c_int as libc::c_long &&
                   *__errno_location() == 11 as libc::c_int &&
                   try_0 < 10 as libc::c_int as libc::c_uint {
                if loglevel as libc::c_uint >=
                       lSDEBUG as libc::c_int as libc::c_uint {
                    try_0 = try_0.wrapping_add(1);
                    logprint(b"%s %s:%d retrying (%d) writing to socket\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 12],
                                                       &[libc::c_char; 12]>(b"send_header\x00")).as_ptr(),
                             114 as libc::c_int, try_0);
                }
                usleep(1000 as libc::c_int as __useconds_t);
            } else {
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d failed writing to socket: %s\n\x00" as
                                 *const u8 as *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 12],
                                                       &[libc::c_char; 12]>(b"send_header\x00")).as_ptr(),
                             118 as libc::c_int,
                             strerror(*__errno_location()));
                }
                stream.disconnect = LOCAL_DISCONNECT;
                stream.state = DISCONNECT;
                wake_controller();
                return 0 as libc::c_int != 0
            }
        } else {
            if loglevel as libc::c_uint >=
                   lSDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d wrote %d bytes to socket\n\x00" as
                             *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 12],
                                                   &[libc::c_char; 12]>(b"send_header\x00")).as_ptr(),
                         124 as libc::c_int, n);
            }
            ptr = ptr.offset(n as isize);
            len = (len as libc::c_long - n) as libc::c_int
        }
    }
    if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d wrote header\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 12],
                                           &[libc::c_char; 12]>(b"send_header\x00")).as_ptr(),
                 128 as libc::c_int);
    }
    return 1 as libc::c_int != 0;
}
static mut running: bool = 1 as libc::c_int != 0;
unsafe extern "C" fn _disconnect(mut state: stream_state,
                                 mut disconnect: disconnect_code) {
    stream.state = state;
    stream.disconnect = disconnect;
    close(fd);
    fd = -(1 as libc::c_int);
    wake_controller();
}
unsafe extern "C" fn stream_thread() -> *mut libc::c_void {
    while running {
        let mut pollinfo: pollfd = pollfd{fd: 0, events: 0, revents: 0,};
        let mut space: size_t = 0;
        pthread_mutex_lock(&mut (*streambuf).mutex);
        space =
            if _buf_space(streambuf) < _buf_cont_write(streambuf) {
                _buf_space(streambuf)
            } else { _buf_cont_write(streambuf) } as size_t;
        if fd < 0 as libc::c_int || space == 0 ||
               stream.state as libc::c_uint <=
                   STREAMING_WAIT as libc::c_int as libc::c_uint {
            pthread_mutex_unlock(&mut (*streambuf).mutex);
            usleep(100000 as libc::c_int as __useconds_t);
        } else if stream.state as libc::c_uint ==
                      STREAMING_FILE as libc::c_int as libc::c_uint {
            let mut n: libc::c_int =
                read(fd, (*streambuf).writep as *mut libc::c_void, space) as
                    libc::c_int;
            if n == 0 as libc::c_int {
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d end of stream\n\x00" as *const u8 as
                                 *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 14],
                                                       &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                             170 as libc::c_int);
                }
                _disconnect(DISCONNECT, DISCONNECT_OK);
            }
            if n > 0 as libc::c_int {
                _buf_inc_writep(streambuf, n as libc::c_uint);
                stream.bytes =
                    (stream.bytes as
                         libc::c_ulong).wrapping_add(n as libc::c_ulong) as
                        u64_t as u64_t;
                if loglevel as libc::c_uint >=
                       lSDEBUG as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d streambuf read %d bytes\n\x00" as
                                 *const u8 as *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 14],
                                                       &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                             176 as libc::c_int, n);
                }
            }
            if n < 0 as libc::c_int {
                if loglevel as libc::c_uint >=
                       lWARN as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d error reading: %s\n\x00" as *const u8
                                 as *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 14],
                                                       &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                             179 as libc::c_int,
                             strerror(*__errno_location()));
                }
                _disconnect(DISCONNECT, REMOTE_DISCONNECT);
            }
            pthread_mutex_unlock(&mut (*streambuf).mutex);
        } else {
            pollinfo.fd = fd;
            pollinfo.events = 0x1 as libc::c_int as libc::c_short;
            if stream.state as libc::c_uint ==
                   SEND_HEADERS as libc::c_int as libc::c_uint {
                pollinfo.events =
                    (pollinfo.events as libc::c_int | 0x4 as libc::c_int) as
                        libc::c_short
            }
            pthread_mutex_unlock(&mut (*streambuf).mutex);
            if poll(&mut pollinfo, 1 as libc::c_int as nfds_t,
                    100 as libc::c_int) != 0 {
                pthread_mutex_lock(&mut (*streambuf).mutex);
                // check socket has not been closed while in poll
                if fd < 0 as libc::c_int {
                    pthread_mutex_unlock(&mut (*streambuf).mutex);
                } else if pollinfo.revents as libc::c_int & 0x4 as libc::c_int
                              != 0 &&
                              stream.state as libc::c_uint ==
                                  SEND_HEADERS as libc::c_int as libc::c_uint
                 {
                    if send_header() { stream.state = RECV_HEADERS }
                    stream.header_len = 0 as libc::c_int as size_t;
                    pthread_mutex_unlock(&mut (*streambuf).mutex);
                } else {
                    if pollinfo.revents as libc::c_int &
                           (0x1 as libc::c_int | 0x10 as libc::c_int) != 0 {
                        // get response headers
                        if stream.state as libc::c_uint ==
                               RECV_HEADERS as libc::c_int as libc::c_uint {
                            // read one byte at a time to catch end of header
                            let mut c: libc::c_char = 0;
                            static mut endtok: libc::c_int = 0;
                            let mut n_0: libc::c_int =
                                recv(fd,
                                     &mut c as *mut libc::c_char as
                                         *mut libc::c_void,
                                     1 as libc::c_int as size_t,
                                     0 as libc::c_int) as libc::c_int;
                            if n_0 <= 0 as libc::c_int {
                                if n_0 < 0 as libc::c_int &&
                                       *__errno_location() ==
                                           11 as libc::c_int {
                                    pthread_mutex_unlock(&mut (*streambuf).mutex);
                                    continue ;
                                } else {
                                    if loglevel as libc::c_uint >=
                                           lINFO as libc::c_int as
                                               libc::c_uint {
                                        logprint(b"%s %s:%d error reading headers: %s\n\x00"
                                                     as *const u8 as
                                                     *const libc::c_char,
                                                 logtime(),
                                                 (*::std::mem::transmute::<&[u8; 14],
                                                                           &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                                                 229 as libc::c_int,
                                                 if n_0 != 0 {
                                                     strerror(*__errno_location())
                                                         as
                                                         *const libc::c_char
                                                 } else {
                                                     b"closed\x00" as
                                                         *const u8 as
                                                         *const libc::c_char
                                                 });
                                    }
                                    _disconnect(STOPPED, LOCAL_DISCONNECT);
                                    pthread_mutex_unlock(&mut (*streambuf).mutex);
                                    continue ;
                                }
                            } else {
                                *stream.header.offset(stream.header_len as
                                                          isize) = c;
                                stream.header_len =
                                    stream.header_len.wrapping_add(1);
                                if stream.header_len >
                                       (4096 as libc::c_int -
                                            1 as libc::c_int) as libc::c_ulong
                                   {
                                    logprint(b"%s %s:%d received headers too long: %u\n\x00"
                                                 as *const u8 as
                                                 *const libc::c_char,
                                             logtime(),
                                             (*::std::mem::transmute::<&[u8; 14],
                                                                       &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                                             239 as libc::c_int,
                                             stream.header_len);
                                    _disconnect(DISCONNECT, LOCAL_DISCONNECT);
                                }
                                if stream.header_len >
                                       1 as libc::c_int as libc::c_ulong &&
                                       (c as libc::c_int == '\r' as i32 ||
                                            c as libc::c_int == '\n' as i32) {
                                    endtok += 1;
                                    if endtok == 4 as libc::c_int {
                                        *stream.header.offset(stream.header_len
                                                                  as isize) =
                                            '\u{0}' as i32 as libc::c_char;
                                        if loglevel as libc::c_uint >=
                                               lINFO as libc::c_int as
                                                   libc::c_uint {
                                            logprint(b"%s %s:%d headers: len: %d\n%s\n\x00"
                                                         as *const u8 as
                                                         *const libc::c_char,
                                                     logtime(),
                                                     (*::std::mem::transmute::<&[u8; 14],
                                                                               &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                                                     247 as libc::c_int,
                                                     stream.header_len,
                                                     stream.header);
                                        }
                                        stream.state =
                                            if stream.cont_wait as libc::c_int
                                                   != 0 {
                                                STREAMING_WAIT as libc::c_int
                                            } else {
                                                STREAMING_BUFFERING as
                                                    libc::c_int
                                            } as stream_state;
                                        wake_controller();
                                    }
                                } else { endtok = 0 as libc::c_int }
                                pthread_mutex_unlock(&mut (*streambuf).mutex);
                                continue ;
                            }
                        } else if stream.meta_interval != 0 &&
                                      stream.meta_next ==
                                          0 as libc::c_int as libc::c_uint {
                            if stream.meta_left ==
                                   0 as libc::c_int as libc::c_uint {
                                // receive icy meta data
                                // read meta length
                                let mut c_0: u8_t = 0;
                                let mut n_1: libc::c_int =
                                    recv(fd,
                                         &mut c_0 as *mut u8_t as
                                             *mut libc::c_void,
                                         1 as libc::c_int as size_t,
                                         0 as libc::c_int) as libc::c_int;
                                if n_1 <= 0 as libc::c_int {
                                    if n_1 < 0 as libc::c_int &&
                                           *__errno_location() ==
                                               11 as libc::c_int {
                                        pthread_mutex_unlock(&mut (*streambuf).mutex);
                                        continue ;
                                    } else {
                                        if loglevel as libc::c_uint >=
                                               lINFO as libc::c_int as
                                                   libc::c_uint {
                                            logprint(b"%s %s:%d error reading icy meta: %s\n\x00"
                                                         as *const u8 as
                                                         *const libc::c_char,
                                                     logtime(),
                                                     (*::std::mem::transmute::<&[u8; 14],
                                                                               &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                                                     271 as libc::c_int,
                                                     if n_1 != 0 {
                                                         strerror(*__errno_location())
                                                             as
                                                             *const libc::c_char
                                                     } else {
                                                         b"closed\x00" as
                                                             *const u8 as
                                                             *const libc::c_char
                                                     });
                                        }
                                        _disconnect(STOPPED,
                                                    LOCAL_DISCONNECT);
                                        pthread_mutex_unlock(&mut (*streambuf).mutex);
                                        continue ;
                                    }
                                } else {
                                    stream.meta_left =
                                        (16 as libc::c_int *
                                             c_0 as libc::c_int) as u32_t;
                                    stream.header_len =
                                        0 as libc::c_int as size_t
                                }
                                // amount of received meta data
                                // MAX_HEADER must be more than meta max of 16 * 255
                            }
                            if stream.meta_left != 0 {
                                let mut n_2: libc::c_int =
                                    recv(fd,
                                         stream.header.offset(stream.header_len
                                                                  as isize) as
                                             *mut libc::c_void,
                                         stream.meta_left as size_t,
                                         0 as libc::c_int) as libc::c_int;
                                if n_2 <= 0 as libc::c_int {
                                    if n_2 < 0 as libc::c_int &&
                                           *__errno_location() ==
                                               11 as libc::c_int {
                                        pthread_mutex_unlock(&mut (*streambuf).mutex);
                                        continue ;
                                    } else {
                                        if loglevel as libc::c_uint >=
                                               lINFO as libc::c_int as
                                                   libc::c_uint {
                                            logprint(b"%s %s:%d error reading icy meta: %s\n\x00"
                                                         as *const u8 as
                                                         *const libc::c_char,
                                                     logtime(),
                                                     (*::std::mem::transmute::<&[u8; 14],
                                                                               &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                                                     288 as libc::c_int,
                                                     if n_2 != 0 {
                                                         strerror(*__errno_location())
                                                             as
                                                             *const libc::c_char
                                                     } else {
                                                         b"closed\x00" as
                                                             *const u8 as
                                                             *const libc::c_char
                                                     });
                                        }
                                        _disconnect(STOPPED,
                                                    LOCAL_DISCONNECT);
                                        pthread_mutex_unlock(&mut (*streambuf).mutex);
                                        continue ;
                                    }
                                } else {
                                    stream.meta_left =
                                        (stream.meta_left as
                                             libc::c_uint).wrapping_sub(n_2 as
                                                                            libc::c_uint)
                                            as u32_t as u32_t;
                                    stream.header_len =
                                        (stream.header_len as
                                             libc::c_ulong).wrapping_add(n_2
                                                                             as
                                                                             libc::c_ulong)
                                            as size_t as size_t
                                }
                            }
                            if stream.meta_left ==
                                   0 as libc::c_int as libc::c_uint {
                                if stream.header_len != 0 {
                                    *stream.header.offset(stream.header_len as
                                                              isize) =
                                        '\u{0}' as i32 as libc::c_char;
                                    if loglevel as libc::c_uint >=
                                           lINFO as libc::c_int as
                                               libc::c_uint {
                                        logprint(b"%s %s:%d icy meta: len: %u\n%s\n\x00"
                                                     as *const u8 as
                                                     *const libc::c_char,
                                                 logtime(),
                                                 (*::std::mem::transmute::<&[u8; 14],
                                                                           &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                                                 300 as libc::c_int,
                                                 stream.header_len,
                                                 stream.header);
                                    }
                                    stream.meta_send = 1 as libc::c_int != 0;
                                    wake_controller();
                                }
                                stream.meta_next = stream.meta_interval;
                                pthread_mutex_unlock(&mut (*streambuf).mutex);
                                continue ;
                            }
                            // stream body into streambuf
                        } else {
                            let mut n_3: libc::c_int = 0;
                            space =
                                if _buf_space(streambuf) <
                                       _buf_cont_write(streambuf) {
                                    _buf_space(streambuf)
                                } else { _buf_cont_write(streambuf) } as
                                    size_t;
                            if stream.meta_interval != 0 {
                                space =
                                    if space <
                                           stream.meta_next as libc::c_ulong {
                                        space
                                    } else {
                                        stream.meta_next as libc::c_ulong
                                    }
                            }
                            n_3 =
                                recv(fd,
                                     (*streambuf).writep as *mut libc::c_void,
                                     space, 0 as libc::c_int) as libc::c_int;
                            if n_3 == 0 as libc::c_int {
                                if loglevel as libc::c_uint >=
                                       lINFO as libc::c_int as libc::c_uint {
                                    logprint(b"%s %s:%d end of stream\n\x00"
                                                 as *const u8 as
                                                 *const libc::c_char,
                                             logtime(),
                                             (*::std::mem::transmute::<&[u8; 14],
                                                                       &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                                             320 as libc::c_int);
                                }
                                _disconnect(DISCONNECT, DISCONNECT_OK);
                            }
                            if n_3 < 0 as libc::c_int &&
                                   *__errno_location() != 11 as libc::c_int {
                                if loglevel as libc::c_uint >=
                                       lINFO as libc::c_int as libc::c_uint {
                                    logprint(b"%s %s:%d error reading: %s\n\x00"
                                                 as *const u8 as
                                                 *const libc::c_char,
                                             logtime(),
                                             (*::std::mem::transmute::<&[u8; 14],
                                                                       &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                                             324 as libc::c_int,
                                             strerror(*__errno_location()));
                                }
                                _disconnect(DISCONNECT, REMOTE_DISCONNECT);
                            }
                            if n_3 > 0 as libc::c_int {
                                _buf_inc_writep(streambuf,
                                                n_3 as libc::c_uint);
                                stream.bytes =
                                    (stream.bytes as
                                         libc::c_ulong).wrapping_add(n_3 as
                                                                         libc::c_ulong)
                                        as u64_t as u64_t;
                                if stream.meta_interval != 0 {
                                    stream.meta_next =
                                        (stream.meta_next as
                                             libc::c_uint).wrapping_sub(n_3 as
                                                                            libc::c_uint)
                                            as u32_t as u32_t
                                }
                                if stream.state as libc::c_uint ==
                                       STREAMING_BUFFERING as libc::c_int as
                                           libc::c_uint &&
                                       stream.bytes >
                                           stream.threshold as libc::c_ulong {
                                    stream.state = STREAMING_HTTP;
                                    wake_controller();
                                }
                                if loglevel as libc::c_uint >=
                                       lSDEBUG as libc::c_int as libc::c_uint
                                   {
                                    logprint(b"%s %s:%d streambuf read %d bytes\n\x00"
                                                 as *const u8 as
                                                 *const libc::c_char,
                                             logtime(),
                                             (*::std::mem::transmute::<&[u8; 14],
                                                                       &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                                             344 as libc::c_int, n_3);
                                }
                            } else {
                                pthread_mutex_unlock(&mut (*streambuf).mutex);
                                continue ;
                            }
                        }
                    }
                    pthread_mutex_unlock(&mut (*streambuf).mutex);
                }
            } else if loglevel as libc::c_uint >=
                          lSDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d poll timeout\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 14],
                                                   &[libc::c_char; 14]>(b"stream_thread\x00")).as_ptr(),
                         352 as libc::c_int);
            }
        }
    }
    return 0 as *mut libc::c_void;
}
static mut thread: pthread_t = 0;
#[no_mangle]
pub unsafe extern "C" fn stream_init(mut level: log_level,
                                     mut stream_buf_size: libc::c_uint) {
    loglevel = level;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d init stream\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 12],
                                           &[libc::c_char; 12]>(b"stream_init\x00")).as_ptr(),
                 370 as libc::c_int);
    }
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d streambuf size: %u\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 12],
                                           &[libc::c_char; 12]>(b"stream_init\x00")).as_ptr(),
                 371 as libc::c_int, stream_buf_size);
    }
    buf_init(streambuf, stream_buf_size as size_t);
    if (*streambuf).buf.is_null() {
        logprint(b"%s %s:%d unable to malloc buffer\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 12],
                                           &[libc::c_char; 12]>(b"stream_init\x00")).as_ptr(),
                 375 as libc::c_int);
        exit(0 as libc::c_int);
    }
    stream.state = STOPPED;
    stream.header =
        malloc(4096 as libc::c_int as libc::c_ulong) as *mut libc::c_char;
    *stream.header = '\u{0}' as i32 as libc::c_char;
    fd = -(1 as libc::c_int);
    touch_memory((*streambuf).buf, (*streambuf).size);
    let mut attr: pthread_attr_t = pthread_attr_t{__size: [0; 56],};
    pthread_attr_init(&mut attr);
    pthread_attr_setstacksize(&mut attr,
                              (16384 as libc::c_int +
                                   64 as libc::c_int * 1024 as libc::c_int) as
                                  size_t);
    pthread_create(&mut thread, &mut attr,
                   ::std::mem::transmute::<Option<unsafe extern "C" fn()
                                                      -> *mut libc::c_void>,
                                           Option<unsafe extern "C" fn(_:
                                                                           *mut libc::c_void)
                                                      ->
                                                          *mut libc::c_void>>(Some(::std::mem::transmute::<unsafe extern "C" fn()
                                                                                                               ->
                                                                                                                   *mut libc::c_void,
                                                                                                           unsafe extern "C" fn()
                                                                                                               ->
                                                                                                                   *mut libc::c_void>(stream_thread))),
                   0 as *mut libc::c_void);
    pthread_attr_destroy(&mut attr);
}
#[no_mangle]
pub unsafe extern "C" fn stream_close() {
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d close stream\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"stream_close\x00")).as_ptr(),
                 424 as libc::c_int);
    }
    pthread_mutex_lock(&mut (*streambuf).mutex);
    running = 0 as libc::c_int != 0;
    pthread_mutex_unlock(&mut (*streambuf).mutex);
    pthread_join(thread, 0 as *mut *mut libc::c_void);
    free(stream.header as *mut libc::c_void);
    buf_destroy(streambuf);
}
#[no_mangle]
pub unsafe extern "C" fn stream_file(mut header: *const libc::c_char,
                                     mut header_len: size_t,
                                     mut threshold: libc::c_uint) {
    buf_flush(streambuf);
    pthread_mutex_lock(&mut (*streambuf).mutex);
    stream.header_len = header_len;
    memcpy(stream.header as *mut libc::c_void, header as *const libc::c_void,
           header_len);
    *stream.header.offset(header_len as isize) =
        '\u{0}' as i32 as libc::c_char;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d opening local file: %s\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 12],
                                           &[libc::c_char; 12]>(b"stream_file\x00")).as_ptr(),
                 444 as libc::c_int, stream.header);
    }
    fd = open(stream.header, 0 as libc::c_int);
    stream.state = STREAMING_FILE;
    if fd < 0 as libc::c_int {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d can\'t open file: %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 12],
                                               &[libc::c_char; 12]>(b"stream_file\x00")).as_ptr(),
                     454 as libc::c_int, stream.header);
        }
        stream.state = DISCONNECT
    }
    wake_controller();
    stream.cont_wait = 0 as libc::c_int != 0;
    stream.meta_interval = 0 as libc::c_int as u32_t;
    stream.meta_next = 0 as libc::c_int as u32_t;
    stream.meta_left = 0 as libc::c_int as u32_t;
    stream.meta_send = 0 as libc::c_int != 0;
    stream.sent_headers = 0 as libc::c_int != 0;
    stream.bytes = 0 as libc::c_int as u64_t;
    stream.threshold = threshold;
    pthread_mutex_unlock(&mut (*streambuf).mutex);
}
unsafe extern "C" fn _tcp_connect(mut ip: u32_t, mut port: u16_t)
 -> libc::c_int {
    let mut addr: sockaddr_in =
        sockaddr_in{sin_family: 0,
                    sin_port: 0,
                    sin_addr: in_addr{s_addr: 0,},
                    sin_zero: [0; 8],};
    let mut sock: libc::c_int =
        socket(2 as libc::c_int, SOCK_STREAM as libc::c_int,
               0 as libc::c_int);
    if sock < 0 as libc::c_int {
        logprint(b"%s %s:%d failed to create socket\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"_tcp_connect\x00")).as_ptr(),
                 477 as libc::c_int);
        return -(1 as libc::c_int)
    }
    memset(&mut addr as *mut sockaddr_in as *mut libc::c_void,
           0 as libc::c_int,
           ::std::mem::size_of::<sockaddr_in>() as libc::c_ulong);
    addr.sin_family = 2 as libc::c_int as sa_family_t;
    addr.sin_addr.s_addr = ip;
    addr.sin_port = port;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d connecting to %s:%d\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"_tcp_connect\x00")).as_ptr(),
                 486 as libc::c_int, inet_ntoa(addr.sin_addr),
                 ntohs(addr.sin_port) as libc::c_int);
    }
    set_nonblock(sock);
    if connect_timeout(sock, &mut addr as *mut sockaddr_in as *mut sockaddr,
                       ::std::mem::size_of::<sockaddr_in>() as libc::c_ulong
                           as socklen_t, 10 as libc::c_int) < 0 as libc::c_int
       {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d unable to connect to server\n\x00" as
                         *const u8 as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 13],
                                               &[libc::c_char; 13]>(b"_tcp_connect\x00")).as_ptr(),
                     492 as libc::c_int);
        }
        close(sock);
        return -(1 as libc::c_int)
    }
    return sock;
}
#[no_mangle]
pub unsafe extern "C" fn stream_sock(mut ip: u32_t, mut port: u16_t,
                                     mut header: *const libc::c_char,
                                     mut header_len: size_t,
                                     mut threshold: libc::c_uint,
                                     mut cont_wait: bool) {
    let mut sock: libc::c_int = _tcp_connect(ip, port);
    if sock < 0 as libc::c_int {
        pthread_mutex_lock(&mut (*streambuf).mutex);
        stream.state = DISCONNECT;
        stream.disconnect = UNREACHABLE;
        pthread_mutex_unlock(&mut (*streambuf).mutex);
        return
    }
    buf_flush(streambuf);
    pthread_mutex_lock(&mut (*streambuf).mutex);
    fd = sock;
    stream.state = SEND_HEADERS;
    stream.cont_wait = cont_wait;
    stream.meta_interval = 0 as libc::c_int as u32_t;
    stream.meta_next = 0 as libc::c_int as u32_t;
    stream.meta_left = 0 as libc::c_int as u32_t;
    stream.meta_send = 0 as libc::c_int != 0;
    stream.header_len = header_len;
    memcpy(stream.header as *mut libc::c_void, header as *const libc::c_void,
           header_len);
    *stream.header.offset(header_len as isize) =
        '\u{0}' as i32 as libc::c_char;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d header: %s\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 12],
                                           &[libc::c_char; 12]>(b"stream_sock\x00")).as_ptr(),
                 577 as libc::c_int, stream.header);
    }
    stream.sent_headers = 0 as libc::c_int != 0;
    stream.bytes = 0 as libc::c_int as u64_t;
    stream.threshold = threshold;
    pthread_mutex_unlock(&mut (*streambuf).mutex);
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
#[no_mangle]
pub unsafe extern "C" fn stream_disconnect() -> bool {
    let mut disc: bool = 0 as libc::c_int != 0;
    pthread_mutex_lock(&mut (*streambuf).mutex);
    if fd != -(1 as libc::c_int) {
        close(fd);
        fd = -(1 as libc::c_int);
        disc = 1 as libc::c_int != 0
    }
    stream.state = STOPPED;
    pthread_mutex_unlock(&mut (*streambuf).mutex);
    return disc;
}
