use ::libc;
extern "C" {
    #[no_mangle]
    fn malloc(_: libc::c_ulong) -> *mut libc::c_void;
    #[no_mangle]
    fn free(__ptr: *mut libc::c_void);
    #[no_mangle]
    fn memcpy(_: *mut libc::c_void, _: *const libc::c_void, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn memset(_: *mut libc::c_void, _: libc::c_int, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn dlopen(__file: *const libc::c_char, __mode: libc::c_int)
     -> *mut libc::c_void;
    #[no_mangle]
    fn dlsym(__handle: *mut libc::c_void, __name: *const libc::c_char)
     -> *mut libc::c_void;
    #[no_mangle]
    fn dlerror() -> *mut libc::c_char;
    #[no_mangle]
    fn pthread_mutex_lock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_unlock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn logtime() -> *const libc::c_char;
    #[no_mangle]
    fn logprint(fmt: *const libc::c_char, _: ...);
    #[no_mangle]
    fn _buf_used(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_space(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_cont_read(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_cont_write(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_inc_readp(buf: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn _buf_inc_writep(buf: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn decode_newstream(sample_rate: libc::c_uint,
                        supported_rates: *mut libc::c_uint) -> libc::c_uint;
    #[no_mangle]
    fn _checkfade(_: bool);
    #[no_mangle]
    static mut loglevel: log_level;
    #[no_mangle]
    static mut streambuf: *mut buffer;
    #[no_mangle]
    static mut outputbuf: *mut buffer;
    #[no_mangle]
    static mut stream: streamstate;
    #[no_mangle]
    static mut output: outputstate;
    #[no_mangle]
    static mut decode: decodestate;
}
pub type size_t = libc::c_ulong;
pub type __uint8_t = libc::c_uchar;
pub type __int16_t = libc::c_short;
pub type __int32_t = libc::c_int;
pub type __uint32_t = libc::c_uint;
pub type __int64_t = libc::c_long;
pub type __uint64_t = libc::c_ulong;
pub type int16_t = __int16_t;
pub type int32_t = __int32_t;
pub type int64_t = __int64_t;
pub type u_int8_t = __uint8_t;
pub type u_int32_t = __uint32_t;
pub type u_int64_t = __uint64_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_internal_list {
    pub __prev: *mut __pthread_internal_list,
    pub __next: *mut __pthread_internal_list,
}
pub type __pthread_list_t = __pthread_internal_list;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_mutex_s {
    pub __lock: libc::c_int,
    pub __count: libc::c_uint,
    pub __owner: libc::c_int,
    pub __nusers: libc::c_uint,
    pub __kind: libc::c_int,
    pub __spins: libc::c_short,
    pub __elision: libc::c_short,
    pub __list: __pthread_list_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_mutex_t {
    pub __data: __pthread_mutex_s,
    pub __size: [libc::c_char; 40],
    pub __align: libc::c_long,
}
pub type u8_t = u_int8_t;
pub type u32_t = u_int32_t;
pub type u64_t = u_int64_t;
pub type s16_t = int16_t;
pub type s32_t = int32_t;
pub type frames_t = u32_t;
pub type log_level = libc::c_uint;
pub const lSDEBUG: log_level = 4;
pub const lDEBUG: log_level = 3;
pub const lINFO: log_level = 2;
pub const lWARN: log_level = 1;
pub const lERROR: log_level = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct buffer {
    pub buf: *mut u8_t,
    pub readp: *mut u8_t,
    pub writep: *mut u8_t,
    pub wrap: *mut u8_t,
    pub size: size_t,
    pub base_size: size_t,
    pub mutex: pthread_mutex_t,
}
pub type stream_state = libc::c_uint;
pub const RECV_HEADERS: stream_state = 7;
pub const SEND_HEADERS: stream_state = 6;
pub const STREAMING_HTTP: stream_state = 5;
pub const STREAMING_FILE: stream_state = 4;
pub const STREAMING_BUFFERING: stream_state = 3;
pub const STREAMING_WAIT: stream_state = 2;
pub const DISCONNECT: stream_state = 1;
pub const STOPPED: stream_state = 0;
pub type disconnect_code = libc::c_uint;
pub const TIMEOUT: disconnect_code = 4;
pub const UNREACHABLE: disconnect_code = 3;
pub const REMOTE_DISCONNECT: disconnect_code = 2;
pub const LOCAL_DISCONNECT: disconnect_code = 1;
pub const DISCONNECT_OK: disconnect_code = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct streamstate {
    pub state: stream_state,
    pub disconnect: disconnect_code,
    pub header: *mut libc::c_char,
    pub header_len: size_t,
    pub sent_headers: bool,
    pub cont_wait: bool,
    pub bytes: u64_t,
    pub threshold: libc::c_uint,
    pub meta_interval: u32_t,
    pub meta_next: u32_t,
    pub meta_left: u32_t,
    pub meta_send: bool,
}
pub type decode_state = libc::c_uint;
pub const DECODE_ERROR: decode_state = 4;
pub const DECODE_COMPLETE: decode_state = 3;
pub const DECODE_RUNNING: decode_state = 2;
pub const DECODE_READY: decode_state = 1;
pub const DECODE_STOPPED: decode_state = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct decodestate {
    pub state: decode_state,
    pub new_stream: bool,
    pub mutex: pthread_mutex_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct codec {
    pub id: libc::c_char,
    pub types: *mut libc::c_char,
    pub min_read_bytes: libc::c_uint,
    pub min_space: libc::c_uint,
    pub open: Option<unsafe extern "C" fn(_: u8_t, _: u8_t, _: u8_t, _: u8_t)
                         -> ()>,
    pub close: Option<unsafe extern "C" fn() -> ()>,
    pub decode: Option<unsafe extern "C" fn() -> decode_state>,
}
pub type output_state = libc::c_int;
pub const OUTPUT_START_AT: output_state = 5;
pub const OUTPUT_SKIP_FRAMES: output_state = 4;
pub const OUTPUT_PAUSE_FRAMES: output_state = 3;
pub const OUTPUT_RUNNING: output_state = 2;
pub const OUTPUT_BUFFER: output_state = 1;
pub const OUTPUT_STOPPED: output_state = 0;
pub const OUTPUT_OFF: output_state = -1;
pub type output_format = libc::c_uint;
pub const S16_LE: output_format = 3;
pub const S24_3LE: output_format = 2;
pub const S24_LE: output_format = 1;
pub const S32_LE: output_format = 0;
pub type fade_state = libc::c_uint;
pub const FADE_ACTIVE: fade_state = 2;
pub const FADE_DUE: fade_state = 1;
pub const FADE_INACTIVE: fade_state = 0;
pub type fade_dir = libc::c_uint;
pub const FADE_CROSS: fade_dir = 3;
pub const FADE_DOWN: fade_dir = 2;
pub const FADE_UP: fade_dir = 1;
pub type fade_mode = libc::c_uint;
pub const FADE_INOUT: fade_mode = 4;
pub const FADE_OUT: fade_mode = 3;
pub const FADE_IN: fade_mode = 2;
pub const FADE_CROSSFADE: fade_mode = 1;
pub const FADE_NONE: fade_mode = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct outputstate {
    pub state: output_state,
    pub format: output_format,
    pub device: *const libc::c_char,
    pub buffer: libc::c_uint,
    pub period: libc::c_uint,
    pub track_started: bool,
    pub write_cb: Option<unsafe extern "C" fn(_: frames_t, _: bool, _: s32_t,
                                              _: s32_t, _: s32_t, _: s32_t,
                                              _: *mut *mut s32_t)
                             -> libc::c_int>,
    pub start_frames: libc::c_uint,
    pub frames_played: libc::c_uint,
    pub frames_played_dmp: libc::c_uint,
    pub current_sample_rate: libc::c_uint,
    pub supported_rates: [libc::c_uint; 18],
    pub default_sample_rate: libc::c_uint,
    pub error_opening: bool,
    pub device_frames: libc::c_uint,
    pub updated: u32_t,
    pub track_start_time: u32_t,
    pub current_replay_gain: u32_t,
    pub c2rust_unnamed: C2RustUnnamed,
    pub next_sample_rate: libc::c_uint,
    pub track_start: *mut u8_t,
    pub gainL: u32_t,
    pub gainR: u32_t,
    pub invert: bool,
    pub next_replay_gain: u32_t,
    pub threshold: libc::c_uint,
    pub fade: fade_state,
    pub fade_start: *mut u8_t,
    pub fade_end: *mut u8_t,
    pub fade_dir: fade_dir,
    pub fade_mode: fade_mode,
    pub fade_secs: libc::c_uint,
    pub rate_delay: libc::c_uint,
    pub delay_active: bool,
    pub stop_time: u32_t,
    pub idle_to: u32_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed {
    pub pause_frames: u32_t,
    pub skip_frames: u32_t,
    pub start_at: u32_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct OggVorbis_File {
    pub datasource: *mut libc::c_void,
    pub seekable: libc::c_int,
    pub offset: ogg_int64_t,
    pub end: ogg_int64_t,
    pub oy: ogg_sync_state,
    pub links: libc::c_int,
    pub offsets: *mut ogg_int64_t,
    pub dataoffsets: *mut ogg_int64_t,
    pub serialnos: *mut libc::c_long,
    pub pcmlengths: *mut ogg_int64_t,
    pub vi: *mut vorbis_info,
    pub vc: *mut vorbis_comment,
    pub pcm_offset: ogg_int64_t,
    pub ready_state: libc::c_int,
    pub current_serialno: libc::c_long,
    pub current_link: libc::c_int,
    pub bittrack: libc::c_double,
    pub samptrack: libc::c_double,
    pub os: ogg_stream_state,
    pub vd: vorbis_dsp_state,
    pub vb: vorbis_block,
    pub callbacks: ov_callbacks,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct ov_callbacks {
    pub read_func: Option<unsafe extern "C" fn(_: *mut libc::c_void,
                                               _: size_t, _: size_t,
                                               _: *mut libc::c_void)
                              -> size_t>,
    pub seek_func: Option<unsafe extern "C" fn(_: *mut libc::c_void,
                                               _: ogg_int64_t, _: libc::c_int)
                              -> libc::c_int>,
    pub close_func: Option<unsafe extern "C" fn(_: *mut libc::c_void)
                               -> libc::c_int>,
    pub tell_func: Option<unsafe extern "C" fn(_: *mut libc::c_void)
                              -> libc::c_long>,
}
pub type ogg_int64_t = int64_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct vorbis_block {
    pub pcm: *mut *mut libc::c_float,
    pub opb: oggpack_buffer,
    pub lW: libc::c_long,
    pub W: libc::c_long,
    pub nW: libc::c_long,
    pub pcmend: libc::c_int,
    pub mode: libc::c_int,
    pub eofflag: libc::c_int,
    pub granulepos: ogg_int64_t,
    pub sequence: ogg_int64_t,
    pub vd: *mut vorbis_dsp_state,
    pub localstore: *mut libc::c_void,
    pub localtop: libc::c_long,
    pub localalloc: libc::c_long,
    pub totaluse: libc::c_long,
    pub reap: *mut alloc_chain,
    pub glue_bits: libc::c_long,
    pub time_bits: libc::c_long,
    pub floor_bits: libc::c_long,
    pub res_bits: libc::c_long,
    pub internal: *mut libc::c_void,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct alloc_chain {
    pub ptr: *mut libc::c_void,
    pub next: *mut alloc_chain,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct vorbis_dsp_state {
    pub analysisp: libc::c_int,
    pub vi: *mut vorbis_info,
    pub pcm: *mut *mut libc::c_float,
    pub pcmret: *mut *mut libc::c_float,
    pub pcm_storage: libc::c_int,
    pub pcm_current: libc::c_int,
    pub pcm_returned: libc::c_int,
    pub preextrapolate: libc::c_int,
    pub eofflag: libc::c_int,
    pub lW: libc::c_long,
    pub W: libc::c_long,
    pub nW: libc::c_long,
    pub centerW: libc::c_long,
    pub granulepos: ogg_int64_t,
    pub sequence: ogg_int64_t,
    pub glue_bits: ogg_int64_t,
    pub time_bits: ogg_int64_t,
    pub floor_bits: ogg_int64_t,
    pub res_bits: ogg_int64_t,
    pub backend_state: *mut libc::c_void,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct vorbis_info {
    pub version: libc::c_int,
    pub channels: libc::c_int,
    pub rate: libc::c_long,
    pub bitrate_upper: libc::c_long,
    pub bitrate_nominal: libc::c_long,
    pub bitrate_lower: libc::c_long,
    pub bitrate_window: libc::c_long,
    pub codec_setup: *mut libc::c_void,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct oggpack_buffer {
    pub endbyte: libc::c_long,
    pub endbit: libc::c_int,
    pub buffer: *mut libc::c_uchar,
    pub ptr: *mut libc::c_uchar,
    pub storage: libc::c_long,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct ogg_stream_state {
    pub body_data: *mut libc::c_uchar,
    pub body_storage: libc::c_long,
    pub body_fill: libc::c_long,
    pub body_returned: libc::c_long,
    pub lacing_vals: *mut libc::c_int,
    pub granule_vals: *mut ogg_int64_t,
    pub lacing_storage: libc::c_long,
    pub lacing_fill: libc::c_long,
    pub lacing_packet: libc::c_long,
    pub lacing_returned: libc::c_long,
    pub header: [libc::c_uchar; 282],
    pub header_fill: libc::c_int,
    pub e_o_s: libc::c_int,
    pub b_o_s: libc::c_int,
    pub serialno: libc::c_long,
    pub pageno: libc::c_long,
    pub packetno: ogg_int64_t,
    pub granulepos: ogg_int64_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct vorbis_comment {
    pub user_comments: *mut *mut libc::c_char,
    pub comment_lengths: *mut libc::c_int,
    pub comments: libc::c_int,
    pub vendor: *mut libc::c_char,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct ogg_sync_state {
    pub data: *mut libc::c_uchar,
    pub storage: libc::c_int,
    pub fill: libc::c_int,
    pub returned: libc::c_int,
    pub unsynced: libc::c_int,
    pub headerbytes: libc::c_int,
    pub bodybytes: libc::c_int,
}
// automatically select between floating point (preferred) and fixed point libraries:
// NOTE: works with Tremor version here: http://svn.xiph.org/trunk/Tremor, not vorbisidec.1.0.2 currently in ubuntu
// we take common definations from <vorbis/vorbisfile.h> even though we can use tremor at run time
// tremor's OggVorbis_File struct is normally smaller so this is ok, but padding added to malloc in case it is bigger
#[derive(Copy, Clone)]
#[repr(C)]
pub struct vorbis {
    pub vf: *mut OggVorbis_File,
    pub opened: bool,
    pub write_buf: *mut u8_t,
    pub ov_info: Option<unsafe extern "C" fn(_: *mut OggVorbis_File,
                                             _: libc::c_int)
                            -> *mut vorbis_info>,
    pub ov_clear: Option<unsafe extern "C" fn(_: *mut OggVorbis_File)
                             -> libc::c_int>,
    pub ov_read: Option<unsafe extern "C" fn(_: *mut OggVorbis_File,
                                             _: *mut libc::c_char,
                                             _: libc::c_int, _: libc::c_int,
                                             _: libc::c_int, _: libc::c_int,
                                             _: *mut libc::c_int)
                            -> libc::c_long>,
    pub ov_read_tremor: Option<unsafe extern "C" fn(_: *mut OggVorbis_File,
                                                    _: *mut libc::c_char,
                                                    _: libc::c_int,
                                                    _: *mut libc::c_int)
                                   -> libc::c_long>,
    pub ov_open_callbacks: Option<unsafe extern "C" fn(_: *mut libc::c_void,
                                                       _: *mut OggVorbis_File,
                                                       _: *const libc::c_char,
                                                       _: libc::c_long,
                                                       _: ov_callbacks)
                                      -> libc::c_int>,
}
static mut v: *mut vorbis = 0 as *const vorbis as *mut vorbis;
// called with mutex locked within vorbis_decode to avoid locking O before S
unsafe extern "C" fn _read_cb(mut ptr: *mut libc::c_void, mut size: size_t,
                              mut nmemb: size_t,
                              mut datasource: *mut libc::c_void) -> size_t {
    let mut bytes: size_t = 0;
    pthread_mutex_lock(&mut (*streambuf).mutex);
    bytes =
        if _buf_used(streambuf) < _buf_cont_read(streambuf) {
            _buf_used(streambuf)
        } else { _buf_cont_read(streambuf) } as size_t;
    bytes =
        if bytes < size.wrapping_mul(nmemb) {
            bytes
        } else { size.wrapping_mul(nmemb) };
    memcpy(ptr, (*streambuf).readp as *const libc::c_void, bytes);
    _buf_inc_readp(streambuf, bytes as libc::c_uint);
    pthread_mutex_unlock(&mut (*streambuf).mutex);
    return bytes.wrapping_div(size);
}
// these are needed for older versions of tremor, later versions and libvorbis allow NULL to be used
unsafe extern "C" fn _seek_cb(mut datasource: *mut libc::c_void,
                              mut offset: ogg_int64_t,
                              mut whence: libc::c_int) -> libc::c_int {
    return -(1 as libc::c_int); // samples returned are 16 bits
}
unsafe extern "C" fn _close_cb(mut datasource: *mut libc::c_void)
 -> libc::c_int {
    return 0 as libc::c_int;
}
unsafe extern "C" fn _tell_cb(mut datasource: *mut libc::c_void)
 -> libc::c_long {
    return 0 as libc::c_int as libc::c_long;
}
unsafe extern "C" fn vorbis_decode() -> decode_state {
    static mut channels: libc::c_int = 0;
    let mut frames: frames_t = 0;
    let mut bytes: libc::c_int = 0;
    let mut s: libc::c_int = 0;
    let mut n: libc::c_int = 0;
    let mut write_buf: *mut u8_t = 0 as *mut u8_t;
    pthread_mutex_lock(&mut (*streambuf).mutex);
    if stream.state as libc::c_uint <=
           DISCONNECT as libc::c_int as libc::c_uint &&
           _buf_used(streambuf) == 0 {
        pthread_mutex_unlock(&mut (*streambuf).mutex);
        return DECODE_COMPLETE
    }
    pthread_mutex_unlock(&mut (*streambuf).mutex);
    if decode.new_stream {
        let mut cbs: ov_callbacks =
            ov_callbacks{read_func: None,
                         seek_func: None,
                         close_func: None,
                         tell_func: None,};
        let mut err: libc::c_int = 0;
        let mut info: *mut vorbis_info = 0 as *mut vorbis_info;
        cbs.read_func =
            Some(_read_cb as
                     unsafe extern "C" fn(_: *mut libc::c_void, _: size_t,
                                          _: size_t, _: *mut libc::c_void)
                         -> size_t);
        if (*v).ov_read_tremor.is_some() {
            cbs.seek_func =
                Some(_seek_cb as
                         unsafe extern "C" fn(_: *mut libc::c_void,
                                              _: ogg_int64_t, _: libc::c_int)
                             -> libc::c_int);
            cbs.close_func =
                Some(_close_cb as
                         unsafe extern "C" fn(_: *mut libc::c_void)
                             -> libc::c_int);
            cbs.tell_func =
                Some(_tell_cb as
                         unsafe extern "C" fn(_: *mut libc::c_void)
                             -> libc::c_long)
        } else {
            cbs.seek_func = None;
            cbs.close_func = None;
            cbs.tell_func = None
        }
        err =
            (*v).ov_open_callbacks.expect("non-null function pointer")(streambuf
                                                                           as
                                                                           *mut libc::c_void,
                                                                       (*v).vf,
                                                                       0 as
                                                                           *const libc::c_char,
                                                                       0 as
                                                                           libc::c_int
                                                                           as
                                                                           libc::c_long,
                                                                       cbs);
        if err < 0 as libc::c_int {
            if loglevel as libc::c_uint >=
                   lWARN as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d open_callbacks error: %d\n\x00" as
                             *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 14],
                                                   &[libc::c_char; 14]>(b"vorbis_decode\x00")).as_ptr(),
                         162 as libc::c_int, err);
            }
            return DECODE_COMPLETE
        }
        (*v).opened = 1 as libc::c_int != 0;
        info =
            (*v).ov_info.expect("non-null function pointer")((*v).vf,
                                                             -(1 as
                                                                   libc::c_int));
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d setting track_start\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 14],
                                               &[libc::c_char; 14]>(b"vorbis_decode\x00")).as_ptr(),
                     169 as libc::c_int);
        }
        pthread_mutex_lock(&mut (*outputbuf).mutex);
        output.next_sample_rate =
            decode_newstream((*info).rate as libc::c_uint,
                             output.supported_rates.as_mut_ptr());
        output.track_start = (*outputbuf).writep;
        if output.fade_mode as u64 != 0 { _checkfade(1 as libc::c_int != 0); }
        decode.new_stream = 0 as libc::c_int != 0;
        pthread_mutex_unlock(&mut (*outputbuf).mutex);
        channels = (*info).channels;
        if channels > 2 as libc::c_int {
            if loglevel as libc::c_uint >=
                   lWARN as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d too many channels: %d\n\x00" as *const u8
                             as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 14],
                                                   &[libc::c_char; 14]>(b"vorbis_decode\x00")).as_ptr(),
                         181 as libc::c_int, channels);
            }
            return DECODE_ERROR
        }
    }
    frames =
        (if _buf_space(outputbuf) < _buf_cont_write(outputbuf) {
             _buf_space(outputbuf)
         } else {
             _buf_cont_write(outputbuf)
         }).wrapping_div(8 as libc::c_int as libc::c_uint);
    write_buf = (*v).write_buf;
    frames =
        if frames < 2048 as libc::c_int as libc::c_uint {
            frames
        } else { 2048 as libc::c_int as libc::c_uint };
    bytes =
        frames.wrapping_mul(2 as libc::c_int as
                                libc::c_uint).wrapping_mul(channels as
                                                               libc::c_uint)
            as libc::c_int;
    // write the decoded frames into outputbuf even though they are 16 bits per sample, then unpack them
    if (*v).ov_read_tremor.is_none() {
        n =
            (*v).ov_read.expect("non-null function pointer")((*v).vf,
                                                             write_buf as
                                                                 *mut libc::c_char,
                                                             bytes,
                                                             0 as libc::c_int,
                                                             2 as libc::c_int,
                                                             1 as libc::c_int,
                                                             &mut s) as
                libc::c_int
    } else {
        n =
            (*v).ov_read_tremor.expect("non-null function pointer")((*v).vf,
                                                                    write_buf
                                                                        as
                                                                        *mut libc::c_char,
                                                                    bytes,
                                                                    &mut s) as
                libc::c_int
    }
    pthread_mutex_lock(&mut (*outputbuf).mutex);
    if n > 0 as libc::c_int {
        let mut count: frames_t = 0;
        let mut iptr: *mut s16_t = 0 as *mut s16_t;
        let mut optr: *mut s32_t = 0 as *mut s32_t;
        frames = (n / 2 as libc::c_int / channels) as frames_t;
        count = frames.wrapping_mul(channels as libc::c_uint);
        iptr = (write_buf as *mut s16_t).offset(count as isize);
        optr =
            ((*outputbuf).writep as
                 *mut s32_t).offset(frames.wrapping_mul(2 as libc::c_int as
                                                            libc::c_uint) as
                                        isize);
        if channels == 2 as libc::c_int {
            loop  {
                let fresh0 = count;
                count = count.wrapping_sub(1);
                if !(fresh0 != 0) { break ; }
                iptr = iptr.offset(-1);
                optr = optr.offset(-1);
                *optr = (*iptr as libc::c_int) << 16 as libc::c_int
            }
        } else if channels == 1 as libc::c_int {
            loop  {
                let fresh1 = count;
                count = count.wrapping_sub(1);
                if !(fresh1 != 0) { break ; }
                iptr = iptr.offset(-1);
                optr = optr.offset(-1);
                *optr = (*iptr as libc::c_int) << 16 as libc::c_int;
                optr = optr.offset(-1);
                *optr = (*iptr as libc::c_int) << 16 as libc::c_int
            }
        }
        _buf_inc_writep(outputbuf,
                        frames.wrapping_mul(8 as libc::c_int as
                                                libc::c_uint));
        if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint
           {
            logprint(b"%s %s:%d wrote %u frames\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 14],
                                               &[libc::c_char; 14]>(b"vorbis_decode\x00")).as_ptr(),
                     265 as libc::c_int, frames);
        }
    } else if n == 0 as libc::c_int {
        if stream.state as libc::c_uint <=
               DISCONNECT as libc::c_int as libc::c_uint {
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d partial decode\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 14],
                                                   &[libc::c_char; 14]>(b"vorbis_decode\x00")).as_ptr(),
                         270 as libc::c_int);
            }
            pthread_mutex_unlock(&mut (*outputbuf).mutex);
            return DECODE_COMPLETE
        } else {
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d no frame decoded\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 14],
                                                   &[libc::c_char; 14]>(b"vorbis_decode\x00")).as_ptr(),
                         274 as libc::c_int);
            }
        }
    } else if n == -(3 as libc::c_int) {
        // recoverable hole in stream, seen when skipping
        if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d hole in stream\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 14],
                                               &[libc::c_char; 14]>(b"vorbis_decode\x00")).as_ptr(),
                     280 as
                         libc::c_int); // add some padding as struct size may be larger
        }
    } else {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d ov_read error: %d\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 14],
                                               &[libc::c_char; 14]>(b"vorbis_decode\x00")).as_ptr(),
                     284 as libc::c_int, n);
        }
        pthread_mutex_unlock(&mut (*outputbuf).mutex);
        return DECODE_COMPLETE
    }
    pthread_mutex_unlock(&mut (*outputbuf).mutex);
    return DECODE_RUNNING;
}
unsafe extern "C" fn vorbis_open(mut size: u8_t, mut rate: u8_t,
                                 mut chan: u8_t, mut endianness: u8_t) {
    if (*v).vf.is_null() {
        (*v).vf =
            malloc((::std::mem::size_of::<OggVorbis_File>() as
                        libc::c_ulong).wrapping_add(128 as libc::c_int as
                                                        libc::c_ulong)) as
                *mut OggVorbis_File;
        memset((*v).vf as *mut libc::c_void, 0 as libc::c_int,
               (::std::mem::size_of::<OggVorbis_File>() as
                    libc::c_ulong).wrapping_add(128 as libc::c_int as
                                                    libc::c_ulong));
        (*v).write_buf =
            malloc((2048 as libc::c_int * 8 as libc::c_int) as libc::c_ulong)
                as *mut u8_t
    } else if (*v).opened {
        (*v).ov_clear.expect("non-null function pointer")((*v).vf);
        (*v).opened = 0 as libc::c_int != 0
    };
}
unsafe extern "C" fn vorbis_close() {
    if (*v).opened {
        (*v).ov_clear.expect("non-null function pointer")((*v).vf);
        (*v).opened = 0 as libc::c_int != 0
    }
    free((*v).vf as *mut libc::c_void);
    free((*v).write_buf as *mut libc::c_void);
    (*v).write_buf = 0 as *mut u8_t;
    (*v).vf = 0 as *mut OggVorbis_File;
}
unsafe extern "C" fn load_vorbis() -> bool {
    let mut handle: *mut libc::c_void =
        dlopen(b"libvorbisfile.so.3\x00" as *const u8 as *const libc::c_char,
               0x2 as libc::c_int);
    let mut err: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut tremor: bool = 0 as libc::c_int != 0;
    if handle.is_null() {
        handle =
            dlopen(b"libvorbisidec.so.1\x00" as *const u8 as
                       *const libc::c_char, 0x2 as libc::c_int);
        if !handle.is_null() {
            tremor = 1 as libc::c_int != 0
        } else {
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d dlerror: %s\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 12],
                                                   &[libc::c_char; 12]>(b"load_vorbis\x00")).as_ptr(),
                         332 as libc::c_int, dlerror());
            }
            return 0 as libc::c_int != 0
        }
    }
    (*v).ov_read =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut OggVorbis_File,
                                                            _:
                                                                *mut libc::c_char,
                                                            _: libc::c_int,
                                                            _: libc::c_int,
                                                            _: libc::c_int,
                                                            _: libc::c_int,
                                                            _:
                                                                *mut libc::c_int)
                                           ->
                                               libc::c_long>>(if tremor as
                                                                     libc::c_int
                                                                     != 0 {
                                                                  0 as
                                                                      *mut libc::c_void
                                                              } else {
                                                                  dlsym(handle,
                                                                        b"ov_read\x00"
                                                                            as
                                                                            *const u8
                                                                            as
                                                                            *const libc::c_char)
                                                              });
    (*v).ov_read_tremor =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut OggVorbis_File,
                                                            _:
                                                                *mut libc::c_char,
                                                            _: libc::c_int,
                                                            _:
                                                                *mut libc::c_int)
                                           ->
                                               libc::c_long>>(if tremor as
                                                                     libc::c_int
                                                                     != 0 {
                                                                  dlsym(handle,
                                                                        b"ov_read\x00"
                                                                            as
                                                                            *const u8
                                                                            as
                                                                            *const libc::c_char)
                                                              } else {
                                                                  0 as
                                                                      *mut libc::c_void
                                                              });
    (*v).ov_info =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut OggVorbis_File,
                                                            _: libc::c_int)
                                           ->
                                               *mut vorbis_info>>(dlsym(handle,
                                                                        b"ov_info\x00"
                                                                            as
                                                                            *const u8
                                                                            as
                                                                            *const libc::c_char));
    (*v).ov_clear =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut OggVorbis_File)
                                           ->
                                               libc::c_int>>(dlsym(handle,
                                                                   b"ov_clear\x00"
                                                                       as
                                                                       *const u8
                                                                       as
                                                                       *const libc::c_char));
    (*v).ov_open_callbacks =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut libc::c_void,
                                                            _:
                                                                *mut OggVorbis_File,
                                                            _:
                                                                *const libc::c_char,
                                                            _: libc::c_long,
                                                            _: ov_callbacks)
                                           ->
                                               libc::c_int>>(dlsym(handle,
                                                                   b"ov_open_callbacks\x00"
                                                                       as
                                                                       *const u8
                                                                       as
                                                                       *const libc::c_char));
    err = dlerror();
    if !err.is_null() {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d dlerror: %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 12],
                                               &[libc::c_char; 12]>(b"load_vorbis\x00")).as_ptr(),
                     344 as libc::c_int, err);
        }
        return 0 as libc::c_int != 0
    }
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d loaded %s\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 12],
                                           &[libc::c_char; 12]>(b"load_vorbis\x00")).as_ptr(),
                 348 as libc::c_int,
                 if tremor as libc::c_int != 0 {
                     b"libvorbisidec.so.1\x00" as *const u8 as
                         *const libc::c_char
                 } else {
                     b"libvorbisfile.so.3\x00" as *const u8 as
                         *const libc::c_char
                 });
    }
    return 1 as libc::c_int != 0;
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
// output.c output_alsa.c output_pa.c output_pack.c
// frames played at the point delay is measured
// ordered largest first so [0] is max_rate
// set in decode thread
// set in decode thread
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// _* called with mutex locked
// output_alsa.c
// output_pa.c
// output_pulse.c
// output_stdout.c
// output_pack.c
// output_vis.c
// dop.c
// codecs
#[no_mangle]
pub unsafe extern "C" fn register_vorbis() -> *mut codec {
    static mut ret: codec =
        unsafe {
            {
                let mut init =
                    codec{id: 'o' as i32 as libc::c_char,
                          types:
                              b"ogg\x00" as *const u8 as *const libc::c_char
                                  as *mut libc::c_char,
                          min_read_bytes: 4096 as libc::c_int as libc::c_uint,
                          min_space: 20480 as libc::c_int as libc::c_uint,
                          open:
                              Some(vorbis_open as
                                       unsafe extern "C" fn(_: u8_t, _: u8_t,
                                                            _: u8_t, _: u8_t)
                                           -> ()),
                          close:
                              Some(vorbis_close as
                                       unsafe extern "C" fn() -> ()),
                          decode:
                              Some(vorbis_decode as
                                       unsafe extern "C" fn()
                                           -> decode_state),};
                init
            }
        };
    v =
        malloc(::std::mem::size_of::<vorbis>() as libc::c_ulong) as
            *mut vorbis;
    if v.is_null() { return 0 as *mut codec }
    (*v).vf = 0 as *mut OggVorbis_File;
    (*v).opened = 0 as libc::c_int != 0;
    if !load_vorbis() { return 0 as *mut codec }
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d using vorbis to decode ogg\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 16],
                                           &[libc::c_char; 16]>(b"register_vorbis\x00")).as_ptr(),
                 377 as libc::c_int);
    }
    return &mut ret;
}
